/* geary-config.c generated by valac 0.46.13, the Vala compiler
 * generated from geary-config.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include "geary-engine.h"
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>

#define TYPE_CONFIGURATION (configuration_get_type ())
#define CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIGURATION, Configuration))
#define CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIGURATION, ConfigurationClass))
#define IS_CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIGURATION))
#define IS_CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIGURATION))
#define CONFIGURATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIGURATION, ConfigurationClass))

typedef struct _Configuration Configuration;
typedef struct _ConfigurationClass ConfigurationClass;
typedef struct _ConfigurationPrivate ConfigurationPrivate;
typedef enum  {
	CONFIGURATION_DESKTOP_ENVIRONMENT_UNKNOWN = 0,
	CONFIGURATION_DESKTOP_ENVIRONMENT_UNITY
} ConfigurationDesktopEnvironment;

#define CONFIGURATION_TYPE_DESKTOP_ENVIRONMENT (configuration_desktop_environment_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef enum  {
	UTIL_DATE_CLOCK_FORMAT_TWELVE_HOURS,
	UTIL_DATE_CLOCK_FORMAT_TWENTY_FOUR_HOURS,
	UTIL_DATE_CLOCK_FORMAT_LOCALE_DEFAULT,
	UTIL_DATE_CLOCK_FORMAT_TOTAL
} UtilDateClockFormat;

#define UTIL_DATE_TYPE_CLOCK_FORMAT (util_date_clock_format_get_type ())
typedef struct _ParamSpecConfiguration ParamSpecConfiguration;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Configuration {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ConfigurationPrivate * priv;
};

struct _ConfigurationClass {
	GTypeClass parent_class;
	void (*finalize) (Configuration *self);
};

struct _ConfigurationPrivate {
	GSettings* _settings;
	GSettings* _gnome_interface;
	gboolean _enable_debug;
	gboolean _enable_inspector;
	gboolean _revoke_certs;
};

struct _ParamSpecConfiguration {
	GParamSpec parent_instance;
};

static gint Configuration_private_offset;
static gpointer configuration_parent_class = NULL;

gpointer configuration_ref (gpointer instance);
void configuration_unref (gpointer instance);
GParamSpec* param_spec_configuration (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
void value_set_configuration (GValue* value,
                              gpointer v_object);
void value_take_configuration (GValue* value,
                               gpointer v_object);
gpointer value_get_configuration (const GValue* value);
GType configuration_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Configuration, configuration_unref)
GType configuration_desktop_environment_get_type (void) G_GNUC_CONST;
#define CONFIGURATION_WINDOW_WIDTH_KEY "window-width"
#define CONFIGURATION_WINDOW_HEIGHT_KEY "window-height"
#define CONFIGURATION_WINDOW_MAXIMIZE_KEY "window-maximize"
#define CONFIGURATION_FOLDER_LIST_PANE_POSITION_KEY "folder-list-pane-position"
#define CONFIGURATION_FOLDER_LIST_PANE_POSITION_HORIZONTAL_KEY "folder-list-pane-position-horizontal"
#define CONFIGURATION_FOLDER_LIST_PANE_POSITION_VERTICAL_KEY "folder-list-pane-position-vertical"
#define CONFIGURATION_FOLDER_LIST_PANE_HORIZONTAL_KEY "folder-list-pane-horizontal"
#define CONFIGURATION_MESSAGES_PANE_POSITION_KEY "messages-pane-position"
#define CONFIGURATION_AUTOSELECT_KEY "autoselect"
#define CONFIGURATION_DISPLAY_PREVIEW_KEY "display-preview"
#define CONFIGURATION_PLAY_SOUNDS_KEY "play-sounds"
#define CONFIGURATION_SHOW_NOTIFICATIONS_KEY "show-notifications"
#define CONFIGURATION_STARTUP_NOTIFICATIONS_KEY "startup-notifications"
#define CONFIGURATION_ASK_OPEN_ATTACHMENT_KEY "ask-open-attachment"
#define CONFIGURATION_COMPOSE_AS_HTML_KEY "compose-as-html"
#define CONFIGURATION_SPELL_CHECK_VISIBLE_LANGUAGES "spell-check-visible-languages"
#define CONFIGURATION_SPELL_CHECK_LANGUAGES "spell-check-languages"
#define CONFIGURATION_SEARCH_STRATEGY_KEY "search-strategy"
#define CONFIGURATION_CONVERSATION_VIEWER_ZOOM_KEY "conversation-viewer-zoom"
#define CONFIGURATION_COMPOSER_WINDOW_SIZE_KEY "composer-window-size"
#define CONFIGURATION_CLOCK_FORMAT_KEY "clock-format"
void configuration_init (gboolean is_installed,
                         const gchar* schema_dir);
Configuration* configuration_new (const gchar* schema_id);
Configuration* configuration_construct (GType object_type,
                                        const gchar* schema_id);
static void configuration_set_settings (Configuration* self,
                                 GSettings* value);
static void configuration_set_gnome_interface (Configuration* self,
                                        GSettings* value);
void migrate_old_app_config (GSettings* newSettings,
                             const gchar* old_app_id);
GSettings* configuration_get_settings (Configuration* self);
#define MIGRATE_OLD_APP_ID "org.yorba.geary"
void configuration_bind (Configuration* self,
                         const gchar* key,
                         GObject* object,
                         const gchar* property,
                         GSettingsBindFlags flags);
static void configuration_set_boolean (Configuration* self,
                                const gchar* name,
                                gboolean value);
GearySearchQueryStrategy configuration_get_search_strategy (Configuration* self);
void configuration_set_search_strategy (Configuration* self,
                                        GearySearchQueryStrategy strategy);
GSettings* configuration_get_gnome_interface (Configuration* self);
gboolean configuration_get_enable_debug (Configuration* self);
void configuration_set_enable_debug (Configuration* self,
                                     gboolean value);
gboolean configuration_get_enable_inspector (Configuration* self);
void configuration_set_enable_inspector (Configuration* self,
                                         gboolean value);
gboolean configuration_get_revoke_certs (Configuration* self);
void configuration_set_revoke_certs (Configuration* self,
                                     gboolean value);
ConfigurationDesktopEnvironment configuration_get_desktop_environment (Configuration* self);
gint configuration_get_window_width (Configuration* self);
gint configuration_get_window_height (Configuration* self);
gboolean configuration_get_window_maximize (Configuration* self);
gint configuration_get_folder_list_pane_position_old (Configuration* self);
gint configuration_get_folder_list_pane_position_horizontal (Configuration* self);
void configuration_set_folder_list_pane_position_horizontal (Configuration* self,
                                                             gint value);
gint configuration_get_folder_list_pane_position_vertical (Configuration* self);
gboolean configuration_get_folder_list_pane_horizontal (Configuration* self);
gint configuration_get_messages_pane_position (Configuration* self);
void configuration_set_messages_pane_position (Configuration* self,
                                               gint value);
gboolean configuration_get_autoselect (Configuration* self);
gboolean configuration_get_display_preview (Configuration* self);
gchar** configuration_get_spell_check_languages (Configuration* self,
                                                 gint* result_length1);
gchar** util_international_get_user_preferred_languages (gint* result_length1);
static gchar** _vala_array_dup4 (gchar** self,
                          int length);
void configuration_set_spell_check_languages (Configuration* self,
                                              gchar** value,
                                              gint value_length1);
gchar** configuration_get_spell_check_visible_languages (Configuration* self,
                                                         gint* result_length1);
void configuration_set_spell_check_visible_languages (Configuration* self,
                                                      gchar** value,
                                                      gint value_length1);
gboolean configuration_get_play_sounds (Configuration* self);
gboolean configuration_get_show_notifications (Configuration* self);
gboolean configuration_get_startup_notifications (Configuration* self);
void configuration_set_startup_notifications (Configuration* self,
                                              gboolean value);
GType util_date_clock_format_get_type (void) G_GNUC_CONST;
UtilDateClockFormat configuration_get_clock_format (Configuration* self);
gboolean configuration_get_ask_open_attachment (Configuration* self);
void configuration_set_ask_open_attachment (Configuration* self,
                                            gboolean value);
gboolean configuration_get_compose_as_html (Configuration* self);
void configuration_set_compose_as_html (Configuration* self,
                                        gboolean value);
gdouble configuration_get_conversation_viewer_zoom (Configuration* self);
void configuration_set_conversation_viewer_zoom (Configuration* self,
                                                 gdouble value);
gint* configuration_get_composer_window_size (Configuration* self,
                                              gint* result_length1);
static gint _variant_get2 (GVariant* value);
static gint _variant_get3 (GVariant* value);
void configuration_set_composer_window_size (Configuration* self,
                                             gint* value,
                                             gint value_length1);
static GVariant* _variant_new1 (gint* value,
                         gint value_length1);
static void configuration_finalize (Configuration * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static inline gpointer
configuration_get_instance_private (Configuration* self)
{
	return G_STRUCT_MEMBER_P (self, Configuration_private_offset);
}

GType
configuration_desktop_environment_get_type (void)
{
	static volatile gsize configuration_desktop_environment_type_id__volatile = 0;
	if (g_once_init_enter (&configuration_desktop_environment_type_id__volatile)) {
		static const GEnumValue values[] = {{CONFIGURATION_DESKTOP_ENVIRONMENT_UNKNOWN, "CONFIGURATION_DESKTOP_ENVIRONMENT_UNKNOWN", "unknown"}, {CONFIGURATION_DESKTOP_ENVIRONMENT_UNITY, "CONFIGURATION_DESKTOP_ENVIRONMENT_UNITY", "unity"}, {0, NULL, NULL}};
		GType configuration_desktop_environment_type_id;
		configuration_desktop_environment_type_id = g_enum_register_static ("ConfigurationDesktopEnvironment", values);
		g_once_init_leave (&configuration_desktop_environment_type_id__volatile, configuration_desktop_environment_type_id);
	}
	return configuration_desktop_environment_type_id__volatile;
}

void
configuration_init (gboolean is_installed,
                    const gchar* schema_dir)
{
	if (!is_installed) {
		_vala_assert (schema_dir != NULL, "schema_dir != null");
		g_setenv ("GSETTINGS_SCHEMA_DIR", schema_dir, TRUE);
	}
}

Configuration*
configuration_construct (GType object_type,
                         const gchar* schema_id)
{
	Configuration* self = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	g_return_val_if_fail (schema_id != NULL, NULL);
	self = (Configuration*) g_type_create_instance (object_type);
	_tmp0_ = g_settings_new (schema_id);
	_tmp1_ = _tmp0_;
	configuration_set_settings (self, _tmp1_);
	_g_object_unref0 (_tmp1_);
	_tmp2_ = g_settings_new ("org.gnome.desktop.interface");
	_tmp3_ = _tmp2_;
	configuration_set_gnome_interface (self, _tmp3_);
	_g_object_unref0 (_tmp3_);
	_tmp4_ = self->priv->_settings;
	migrate_old_app_config (_tmp4_, MIGRATE_OLD_APP_ID);
	return self;
}

Configuration*
configuration_new (const gchar* schema_id)
{
	return configuration_construct (TYPE_CONFIGURATION, schema_id);
}

void
configuration_bind (Configuration* self,
                    const gchar* key,
                    GObject* object,
                    const gchar* property,
                    GSettingsBindFlags flags)
{
	GSettings* _tmp0_;
	g_return_if_fail (IS_CONFIGURATION (self));
	g_return_if_fail (key != NULL);
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (object, G_TYPE_OBJECT));
	g_return_if_fail (property != NULL);
	_tmp0_ = self->priv->_settings;
	g_settings_bind (_tmp0_, key, object, property, flags);
}

static gchar*
bool_to_string (gboolean self)
{
	gchar* result = NULL;
	if (self) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup ("true");
		result = _tmp0_;
		return result;
	} else {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("false");
		result = _tmp1_;
		return result;
	}
}

static void
configuration_set_boolean (Configuration* self,
                           const gchar* name,
                           gboolean value)
{
	GSettings* _tmp0_;
	g_return_if_fail (IS_CONFIGURATION (self));
	g_return_if_fail (name != NULL);
	_tmp0_ = self->priv->_settings;
	if (!g_settings_set_boolean (_tmp0_, name, value)) {
		gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp1_ = bool_to_string (value);
		_tmp2_ = _tmp1_;
		g_message ("geary-config.vala:228: Unable to set configuration value %s = %s", name, _tmp2_);
		_g_free0 (_tmp2_);
	}
}

GearySearchQueryStrategy
configuration_get_search_strategy (Configuration* self)
{
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GQuark _tmp7_ = 0U;
	static GQuark _tmp6_label0 = 0;
	static GQuark _tmp6_label1 = 0;
	static GQuark _tmp6_label2 = 0;
	GearySearchQueryStrategy result = 0;
	g_return_val_if_fail (IS_CONFIGURATION (self), 0);
	_tmp0_ = self->priv->_settings;
	_tmp1_ = g_settings_get_string (_tmp0_, CONFIGURATION_SEARCH_STRATEGY_KEY);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_utf8_strdown (_tmp2_, (gssize) -1);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	_tmp5_ = _tmp4_;
	_tmp7_ = (NULL == _tmp5_) ? 0 : g_quark_from_string (_tmp5_);
	g_free (_tmp5_);
	if (_tmp7_ == ((0 != _tmp6_label0) ? _tmp6_label0 : (_tmp6_label0 = g_quark_from_static_string ("exact")))) {
		switch (0) {
			default:
			{
				result = GEARY_SEARCH_QUERY_STRATEGY_EXACT;
				return result;
			}
		}
	} else if (_tmp7_ == ((0 != _tmp6_label1) ? _tmp6_label1 : (_tmp6_label1 = g_quark_from_static_string ("aggressive")))) {
		switch (0) {
			default:
			{
				result = GEARY_SEARCH_QUERY_STRATEGY_AGGRESSIVE;
				return result;
			}
		}
	} else if (_tmp7_ == ((0 != _tmp6_label2) ? _tmp6_label2 : (_tmp6_label2 = g_quark_from_static_string ("horizon")))) {
		switch (0) {
			default:
			{
				result = GEARY_SEARCH_QUERY_STRATEGY_HORIZON;
				return result;
			}
		}
	} else {
		switch (0) {
			default:
			{
				result = GEARY_SEARCH_QUERY_STRATEGY_CONSERVATIVE;
				return result;
			}
		}
	}
}

void
configuration_set_search_strategy (Configuration* self,
                                   GearySearchQueryStrategy strategy)
{
	g_return_if_fail (IS_CONFIGURATION (self));
	switch (strategy) {
		case GEARY_SEARCH_QUERY_STRATEGY_EXACT:
		{
			GSettings* _tmp0_;
			_tmp0_ = self->priv->_settings;
			g_settings_set_string (_tmp0_, CONFIGURATION_SEARCH_STRATEGY_KEY, "exact");
			break;
		}
		case GEARY_SEARCH_QUERY_STRATEGY_AGGRESSIVE:
		{
			GSettings* _tmp1_;
			_tmp1_ = self->priv->_settings;
			g_settings_set_string (_tmp1_, CONFIGURATION_SEARCH_STRATEGY_KEY, "aggressive");
			break;
		}
		case GEARY_SEARCH_QUERY_STRATEGY_HORIZON:
		{
			GSettings* _tmp2_;
			_tmp2_ = self->priv->_settings;
			g_settings_set_string (_tmp2_, CONFIGURATION_SEARCH_STRATEGY_KEY, "horizon");
			break;
		}
		default:
		case GEARY_SEARCH_QUERY_STRATEGY_CONSERVATIVE:
		{
			GSettings* _tmp3_;
			_tmp3_ = self->priv->_settings;
			g_settings_set_string (_tmp3_, CONFIGURATION_SEARCH_STRATEGY_KEY, "conservative");
			break;
		}
	}
}

GSettings*
configuration_get_settings (Configuration* self)
{
	GSettings* result;
	GSettings* _tmp0_;
	g_return_val_if_fail (IS_CONFIGURATION (self), NULL);
	_tmp0_ = self->priv->_settings;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
configuration_set_settings (Configuration* self,
                            GSettings* value)
{
	GSettings* _tmp0_;
	g_return_if_fail (IS_CONFIGURATION (self));
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_settings);
	self->priv->_settings = _tmp0_;
}

GSettings*
configuration_get_gnome_interface (Configuration* self)
{
	GSettings* result;
	GSettings* _tmp0_;
	g_return_val_if_fail (IS_CONFIGURATION (self), NULL);
	_tmp0_ = self->priv->_gnome_interface;
	result = _tmp0_;
	return result;
}

static void
configuration_set_gnome_interface (Configuration* self,
                                   GSettings* value)
{
	GSettings* _tmp0_;
	g_return_if_fail (IS_CONFIGURATION (self));
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_gnome_interface);
	self->priv->_gnome_interface = _tmp0_;
}

gboolean
configuration_get_enable_debug (Configuration* self)
{
	gboolean result;
	g_return_val_if_fail (IS_CONFIGURATION (self), FALSE);
	result = self->priv->_enable_debug;
	return result;
}

void
configuration_set_enable_debug (Configuration* self,
                                gboolean value)
{
	g_return_if_fail (IS_CONFIGURATION (self));
	self->priv->_enable_debug = value;
}

gboolean
configuration_get_enable_inspector (Configuration* self)
{
	gboolean result;
	g_return_val_if_fail (IS_CONFIGURATION (self), FALSE);
	result = self->priv->_enable_inspector;
	return result;
}

void
configuration_set_enable_inspector (Configuration* self,
                                    gboolean value)
{
	g_return_if_fail (IS_CONFIGURATION (self));
	self->priv->_enable_inspector = value;
}

gboolean
configuration_get_revoke_certs (Configuration* self)
{
	gboolean result;
	g_return_val_if_fail (IS_CONFIGURATION (self), FALSE);
	result = self->priv->_revoke_certs;
	return result;
}

void
configuration_set_revoke_certs (Configuration* self,
                                gboolean value)
{
	g_return_if_fail (IS_CONFIGURATION (self));
	self->priv->_revoke_certs = value;
}

ConfigurationDesktopEnvironment
configuration_get_desktop_environment (Configuration* self)
{
	ConfigurationDesktopEnvironment result;
	gchar* xdg_current_desktop = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	g_return_val_if_fail (IS_CONFIGURATION (self), 0);
	_tmp0_ = g_getenv ("XDG_CURRENT_DESKTOP");
	_tmp1_ = g_strdup (_tmp0_);
	xdg_current_desktop = _tmp1_;
	_tmp3_ = xdg_current_desktop;
	if (_tmp3_ != NULL) {
		const gchar* _tmp4_;
		_tmp4_ = xdg_current_desktop;
		_tmp2_ = g_str_has_prefix (_tmp4_, "Unity");
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		result = CONFIGURATION_DESKTOP_ENVIRONMENT_UNITY;
		_g_free0 (xdg_current_desktop);
		return result;
	} else {
		result = CONFIGURATION_DESKTOP_ENVIRONMENT_UNKNOWN;
		_g_free0 (xdg_current_desktop);
		return result;
	}
	_g_free0 (xdg_current_desktop);
}

gint
configuration_get_window_width (Configuration* self)
{
	gint result;
	GSettings* _tmp0_;
	g_return_val_if_fail (IS_CONFIGURATION (self), 0);
	_tmp0_ = self->priv->_settings;
	result = g_settings_get_int (_tmp0_, CONFIGURATION_WINDOW_WIDTH_KEY);
	return result;
}

gint
configuration_get_window_height (Configuration* self)
{
	gint result;
	GSettings* _tmp0_;
	g_return_val_if_fail (IS_CONFIGURATION (self), 0);
	_tmp0_ = self->priv->_settings;
	result = g_settings_get_int (_tmp0_, CONFIGURATION_WINDOW_HEIGHT_KEY);
	return result;
}

gboolean
configuration_get_window_maximize (Configuration* self)
{
	gboolean result;
	GSettings* _tmp0_;
	g_return_val_if_fail (IS_CONFIGURATION (self), FALSE);
	_tmp0_ = self->priv->_settings;
	result = g_settings_get_boolean (_tmp0_, CONFIGURATION_WINDOW_MAXIMIZE_KEY);
	return result;
}

gint
configuration_get_folder_list_pane_position_old (Configuration* self)
{
	gint result;
	GSettings* _tmp0_;
	g_return_val_if_fail (IS_CONFIGURATION (self), 0);
	_tmp0_ = self->priv->_settings;
	result = g_settings_get_int (_tmp0_, CONFIGURATION_FOLDER_LIST_PANE_POSITION_KEY);
	return result;
}

gint
configuration_get_folder_list_pane_position_horizontal (Configuration* self)
{
	gint result;
	GSettings* _tmp0_;
	g_return_val_if_fail (IS_CONFIGURATION (self), 0);
	_tmp0_ = self->priv->_settings;
	result = g_settings_get_int (_tmp0_, CONFIGURATION_FOLDER_LIST_PANE_POSITION_HORIZONTAL_KEY);
	return result;
}

void
configuration_set_folder_list_pane_position_horizontal (Configuration* self,
                                                        gint value)
{
	GSettings* _tmp0_;
	g_return_if_fail (IS_CONFIGURATION (self));
	_tmp0_ = self->priv->_settings;
	g_settings_set_int (_tmp0_, CONFIGURATION_FOLDER_LIST_PANE_POSITION_HORIZONTAL_KEY, value);
}

gint
configuration_get_folder_list_pane_position_vertical (Configuration* self)
{
	gint result;
	GSettings* _tmp0_;
	g_return_val_if_fail (IS_CONFIGURATION (self), 0);
	_tmp0_ = self->priv->_settings;
	result = g_settings_get_int (_tmp0_, CONFIGURATION_FOLDER_LIST_PANE_POSITION_VERTICAL_KEY);
	return result;
}

gboolean
configuration_get_folder_list_pane_horizontal (Configuration* self)
{
	gboolean result;
	GSettings* _tmp0_;
	g_return_val_if_fail (IS_CONFIGURATION (self), FALSE);
	_tmp0_ = self->priv->_settings;
	result = g_settings_get_boolean (_tmp0_, CONFIGURATION_FOLDER_LIST_PANE_HORIZONTAL_KEY);
	return result;
}

gint
configuration_get_messages_pane_position (Configuration* self)
{
	gint result;
	GSettings* _tmp0_;
	g_return_val_if_fail (IS_CONFIGURATION (self), 0);
	_tmp0_ = self->priv->_settings;
	result = g_settings_get_int (_tmp0_, CONFIGURATION_MESSAGES_PANE_POSITION_KEY);
	return result;
}

void
configuration_set_messages_pane_position (Configuration* self,
                                          gint value)
{
	GSettings* _tmp0_;
	g_return_if_fail (IS_CONFIGURATION (self));
	_tmp0_ = self->priv->_settings;
	g_settings_set_int (_tmp0_, CONFIGURATION_MESSAGES_PANE_POSITION_KEY, value);
}

gboolean
configuration_get_autoselect (Configuration* self)
{
	gboolean result;
	GSettings* _tmp0_;
	g_return_val_if_fail (IS_CONFIGURATION (self), FALSE);
	_tmp0_ = self->priv->_settings;
	result = g_settings_get_boolean (_tmp0_, CONFIGURATION_AUTOSELECT_KEY);
	return result;
}

gboolean
configuration_get_display_preview (Configuration* self)
{
	gboolean result;
	GSettings* _tmp0_;
	g_return_val_if_fail (IS_CONFIGURATION (self), FALSE);
	_tmp0_ = self->priv->_settings;
	result = g_settings_get_boolean (_tmp0_, CONFIGURATION_DISPLAY_PREVIEW_KEY);
	return result;
}

static gchar**
_vala_array_dup4 (gchar** self,
                  int length)
{
	if (length >= 0) {
		gchar** result;
		int i;
		result = g_new0 (gchar*, length + 1);
		for (i = 0; i < length; i++) {
			gchar* _tmp0_;
			_tmp0_ = g_strdup (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

gchar**
configuration_get_spell_check_languages (Configuration* self,
                                         gint* result_length1)
{
	gchar** result;
	GVariant* value = NULL;
	GSettings* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	const gchar** _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	gint __tmp5__size_ = 0;
	GVariant* _tmp6_;
	gchar** langs = NULL;
	gchar** _tmp12_;
	gint _tmp12__length1;
	gint langs_length1;
	gint _langs_size_;
	gchar** _tmp13_;
	gint _tmp13__length1;
	g_return_val_if_fail (IS_CONFIGURATION (self), NULL);
	_tmp0_ = self->priv->_settings;
	_tmp1_ = g_settings_get_value (_tmp0_, CONFIGURATION_SPELL_CHECK_LANGUAGES);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_variant_get_maybe (_tmp2_);
	_tmp4_ = _tmp3_;
	_g_variant_unref0 (_tmp2_);
	value = _tmp4_;
	_tmp6_ = value;
	if (_tmp6_ != NULL) {
		GVariant* _tmp7_;
		size_t _tmp8_ = 0;
		const gchar** _tmp9_;
		_tmp7_ = value;
		_tmp9_ = g_variant_get_strv (_tmp7_, &_tmp8_);
		_tmp5_ = (g_free (_tmp5_), NULL);
		_tmp5_ = _tmp9_;
		_tmp5__length1 = _tmp8_;
		__tmp5__size_ = _tmp5__length1;
	} else {
		gint _tmp10_ = 0;
		gchar** _tmp11_;
		_tmp11_ = util_international_get_user_preferred_languages (&_tmp10_);
		_tmp5_ = (g_free (_tmp5_), NULL);
		_tmp5_ = _tmp11_;
		_tmp5__length1 = _tmp10_;
		__tmp5__size_ = _tmp5__length1;
	}
	_tmp12_ = (_tmp5_ != NULL) ? _vala_array_dup4 (_tmp5_, _tmp5__length1) : ((gpointer) _tmp5_);
	_tmp12__length1 = _tmp5__length1;
	langs = _tmp12_;
	langs_length1 = _tmp12__length1;
	_langs_size_ = langs_length1;
	_tmp13_ = langs;
	_tmp13__length1 = langs_length1;
	if (result_length1) {
		*result_length1 = _tmp13__length1;
	}
	result = _tmp13_;
	_tmp5_ = (g_free (_tmp5_), NULL);
	_g_variant_unref0 (value);
	return result;
}

void
configuration_set_spell_check_languages (Configuration* self,
                                         gchar** value,
                                         gint value_length1)
{
	GSettings* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	g_return_if_fail (IS_CONFIGURATION (self));
	_tmp0_ = self->priv->_settings;
	_tmp1_ = g_variant_new_strv (value, value_length1);
	g_variant_ref_sink (_tmp1_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_variant_new_maybe (NULL, _tmp2_);
	g_variant_ref_sink (_tmp3_);
	_tmp4_ = _tmp3_;
	g_settings_set_value (_tmp0_, CONFIGURATION_SPELL_CHECK_LANGUAGES, _tmp4_);
	_g_variant_unref0 (_tmp4_);
	_g_variant_unref0 (_tmp2_);
}

gchar**
configuration_get_spell_check_visible_languages (Configuration* self,
                                                 gint* result_length1)
{
	gchar** result;
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	g_return_val_if_fail (IS_CONFIGURATION (self), NULL);
	_tmp0_ = self->priv->_settings;
	_tmp2_ = _tmp1_ = g_settings_get_strv (_tmp0_, CONFIGURATION_SPELL_CHECK_VISIBLE_LANGUAGES);
	_tmp3_ = _tmp2_;
	_tmp3__length1 = _vala_array_length (_tmp1_);
	if (result_length1) {
		*result_length1 = _tmp3__length1;
	}
	result = _tmp3_;
	return result;
}

void
configuration_set_spell_check_visible_languages (Configuration* self,
                                                 gchar** value,
                                                 gint value_length1)
{
	GSettings* _tmp0_;
	g_return_if_fail (IS_CONFIGURATION (self));
	_tmp0_ = self->priv->_settings;
	g_settings_set_strv (_tmp0_, CONFIGURATION_SPELL_CHECK_VISIBLE_LANGUAGES, value);
}

gboolean
configuration_get_play_sounds (Configuration* self)
{
	gboolean result;
	GSettings* _tmp0_;
	g_return_val_if_fail (IS_CONFIGURATION (self), FALSE);
	_tmp0_ = self->priv->_settings;
	result = g_settings_get_boolean (_tmp0_, CONFIGURATION_PLAY_SOUNDS_KEY);
	return result;
}

gboolean
configuration_get_show_notifications (Configuration* self)
{
	gboolean result;
	GSettings* _tmp0_;
	g_return_val_if_fail (IS_CONFIGURATION (self), FALSE);
	_tmp0_ = self->priv->_settings;
	result = g_settings_get_boolean (_tmp0_, CONFIGURATION_SHOW_NOTIFICATIONS_KEY);
	return result;
}

gboolean
configuration_get_startup_notifications (Configuration* self)
{
	gboolean result;
	GSettings* _tmp0_;
	g_return_val_if_fail (IS_CONFIGURATION (self), FALSE);
	_tmp0_ = self->priv->_settings;
	result = g_settings_get_boolean (_tmp0_, CONFIGURATION_STARTUP_NOTIFICATIONS_KEY);
	return result;
}

void
configuration_set_startup_notifications (Configuration* self,
                                         gboolean value)
{
	g_return_if_fail (IS_CONFIGURATION (self));
	configuration_set_boolean (self, CONFIGURATION_STARTUP_NOTIFICATIONS_KEY, value);
}

UtilDateClockFormat
configuration_get_clock_format (Configuration* self)
{
	UtilDateClockFormat result;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
	g_return_val_if_fail (IS_CONFIGURATION (self), 0);
	_tmp0_ = self->priv->_gnome_interface;
	_tmp1_ = g_settings_get_string (_tmp0_, CONFIGURATION_CLOCK_FORMAT_KEY);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strcmp0 (_tmp2_, "12h") == 0;
	_g_free0 (_tmp2_);
	if (_tmp3_) {
		result = UTIL_DATE_CLOCK_FORMAT_TWELVE_HOURS;
		return result;
	} else {
		result = UTIL_DATE_CLOCK_FORMAT_TWENTY_FOUR_HOURS;
		return result;
	}
}

gboolean
configuration_get_ask_open_attachment (Configuration* self)
{
	gboolean result;
	GSettings* _tmp0_;
	g_return_val_if_fail (IS_CONFIGURATION (self), FALSE);
	_tmp0_ = self->priv->_settings;
	result = g_settings_get_boolean (_tmp0_, CONFIGURATION_ASK_OPEN_ATTACHMENT_KEY);
	return result;
}

void
configuration_set_ask_open_attachment (Configuration* self,
                                       gboolean value)
{
	g_return_if_fail (IS_CONFIGURATION (self));
	configuration_set_boolean (self, CONFIGURATION_ASK_OPEN_ATTACHMENT_KEY, value);
}

gboolean
configuration_get_compose_as_html (Configuration* self)
{
	gboolean result;
	GSettings* _tmp0_;
	g_return_val_if_fail (IS_CONFIGURATION (self), FALSE);
	_tmp0_ = self->priv->_settings;
	result = g_settings_get_boolean (_tmp0_, CONFIGURATION_COMPOSE_AS_HTML_KEY);
	return result;
}

void
configuration_set_compose_as_html (Configuration* self,
                                   gboolean value)
{
	g_return_if_fail (IS_CONFIGURATION (self));
	configuration_set_boolean (self, CONFIGURATION_COMPOSE_AS_HTML_KEY, value);
}

gdouble
configuration_get_conversation_viewer_zoom (Configuration* self)
{
	gdouble result;
	GSettings* _tmp0_;
	g_return_val_if_fail (IS_CONFIGURATION (self), 0.0);
	_tmp0_ = self->priv->_settings;
	result = g_settings_get_double (_tmp0_, CONFIGURATION_CONVERSATION_VIEWER_ZOOM_KEY);
	return result;
}

void
configuration_set_conversation_viewer_zoom (Configuration* self,
                                            gdouble value)
{
	GSettings* _tmp0_;
	g_return_if_fail (IS_CONFIGURATION (self));
	_tmp0_ = self->priv->_settings;
	g_settings_set_double (_tmp0_, CONFIGURATION_CONVERSATION_VIEWER_ZOOM_KEY, value);
}

static gint
_variant_get2 (GVariant* value)
{
	return g_variant_get_int32 (value);
}

static gint
_variant_get3 (GVariant* value)
{
	return g_variant_get_int32 (value);
}

gint*
configuration_get_composer_window_size (Configuration* self,
                                        gint* result_length1)
{
	gint* result;
	gint* size = NULL;
	gint* _tmp0_;
	gint size_length1;
	gint _size_size_;
	GVariant* s = NULL;
	GSettings* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	gint* _tmp14_;
	gint _tmp14__length1;
	g_return_val_if_fail (IS_CONFIGURATION (self), NULL);
	_tmp0_ = g_new0 (gint, 2);
	size = _tmp0_;
	size_length1 = 2;
	_size_size_ = size_length1;
	_tmp1_ = self->priv->_settings;
	_tmp2_ = g_settings_get_value (_tmp1_, CONFIGURATION_COMPOSER_WINDOW_SIZE_KEY);
	s = _tmp2_;
	_tmp3_ = s;
	if (g_variant_n_children (_tmp3_) == ((gsize) 2)) {
		GVariant* _tmp4_;
		GVariant* _tmp5_;
		GVariant* _tmp6_;
		gint _tmp7_;
		GVariant* _tmp8_;
		GVariant* _tmp9_;
		GVariant* _tmp10_;
		gint _tmp11_;
		gint* _tmp12_;
		_tmp4_ = s;
		_tmp5_ = g_variant_get_child_value (_tmp4_, (gsize) 0);
		_tmp6_ = _tmp5_;
		_tmp7_ = _variant_get2 (_tmp6_);
		_tmp8_ = s;
		_tmp9_ = g_variant_get_child_value (_tmp8_, (gsize) 1);
		_tmp10_ = _tmp9_;
		_tmp11_ = _variant_get3 (_tmp10_);
		_tmp12_ = g_new0 (gint, 2);
		_tmp12_[0] = _tmp7_;
		_tmp12_[1] = _tmp11_;
		size = (g_free (size), NULL);
		size = _tmp12_;
		size_length1 = 2;
		_size_size_ = size_length1;
		_g_variant_unref0 (_tmp10_);
		_g_variant_unref0 (_tmp6_);
	} else {
		gint* _tmp13_;
		_tmp13_ = g_new0 (gint, 2);
		_tmp13_[0] = -1;
		_tmp13_[1] = -1;
		size = (g_free (size), NULL);
		size = _tmp13_;
		size_length1 = 2;
		_size_size_ = size_length1;
	}
	_tmp14_ = size;
	_tmp14__length1 = size_length1;
	if (result_length1) {
		*result_length1 = _tmp14__length1;
	}
	result = _tmp14_;
	_g_variant_unref0 (s);
	return result;
}

static GVariant*
_variant_new1 (gint* value,
               gint value_length1)
{
	gint* _tmp1_;
	GVariantBuilder _tmp2_;
	gint _tmp3_;
	_tmp1_ = value;
	g_variant_builder_init (&_tmp2_, G_VARIANT_TYPE ("ai"));
	for (_tmp3_ = 0; _tmp3_ < value_length1; _tmp3_++) {
		g_variant_builder_add_value (&_tmp2_, g_variant_new_int32 (*_tmp1_));
		_tmp1_++;
	}
	return g_variant_ref_sink (g_variant_builder_end (&_tmp2_));
}

void
configuration_set_composer_window_size (Configuration* self,
                                        gint* value,
                                        gint value_length1)
{
	GSettings* _tmp0_;
	GVariant* _tmp4_;
	g_return_if_fail (IS_CONFIGURATION (self));
	_tmp0_ = self->priv->_settings;
	_tmp4_ = _variant_new1 (value, value_length1);
	g_settings_set_value (_tmp0_, CONFIGURATION_COMPOSER_WINDOW_SIZE_KEY, _tmp4_);
	_g_variant_unref0 (_tmp4_);
}

static void
value_configuration_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
value_configuration_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		configuration_unref (value->data[0].v_pointer);
	}
}

static void
value_configuration_copy_value (const GValue* src_value,
                                GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = configuration_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
value_configuration_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
value_configuration_collect_value (GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		Configuration * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = configuration_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
value_configuration_lcopy_value (const GValue* value,
                                 guint n_collect_values,
                                 GTypeCValue* collect_values,
                                 guint collect_flags)
{
	Configuration ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = configuration_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
param_spec_configuration (const gchar* name,
                          const gchar* nick,
                          const gchar* blurb,
                          GType object_type,
                          GParamFlags flags)
{
	ParamSpecConfiguration* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_CONFIGURATION), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
value_get_configuration (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_CONFIGURATION), NULL);
	return value->data[0].v_pointer;
}

void
value_set_configuration (GValue* value,
                         gpointer v_object)
{
	Configuration * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_CONFIGURATION));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_CONFIGURATION));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		configuration_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		configuration_unref (old);
	}
}

void
value_take_configuration (GValue* value,
                          gpointer v_object)
{
	Configuration * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_CONFIGURATION));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_CONFIGURATION));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		configuration_unref (old);
	}
}

static void
configuration_class_init (ConfigurationClass * klass,
                          gpointer klass_data)
{
	configuration_parent_class = g_type_class_peek_parent (klass);
	((ConfigurationClass *) klass)->finalize = configuration_finalize;
	g_type_class_adjust_private_offset (klass, &Configuration_private_offset);
}

static void
configuration_instance_init (Configuration * self,
                             gpointer klass)
{
	self->priv = configuration_get_instance_private (self);
	self->priv->_enable_debug = FALSE;
	self->priv->_enable_inspector = FALSE;
	self->priv->_revoke_certs = FALSE;
	self->ref_count = 1;
}

static void
configuration_finalize (Configuration * obj)
{
	Configuration * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CONFIGURATION, Configuration);
	g_signal_handlers_destroy (self);
	_g_object_unref0 (self->priv->_settings);
	_g_object_unref0 (self->priv->_gnome_interface);
}

/**
 * Provides convenience properties to current Geary GSettings values.
 */
GType
configuration_get_type (void)
{
	static volatile gsize configuration_type_id__volatile = 0;
	if (g_once_init_enter (&configuration_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_configuration_init, value_configuration_free_value, value_configuration_copy_value, value_configuration_peek_pointer, "p", value_configuration_collect_value, "p", value_configuration_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ConfigurationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) configuration_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Configuration), 0, (GInstanceInitFunc) configuration_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType configuration_type_id;
		configuration_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Configuration", &g_define_type_info, &g_define_type_fundamental_info, 0);
		Configuration_private_offset = g_type_add_instance_private (configuration_type_id, sizeof (ConfigurationPrivate));
		g_once_init_leave (&configuration_type_id__volatile, configuration_type_id);
	}
	return configuration_type_id__volatile;
}

gpointer
configuration_ref (gpointer instance)
{
	Configuration * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
configuration_unref (gpointer instance)
{
	Configuration * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		CONFIGURATION_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

