/* util-email.c generated by valac 0.46.13, the Vala compiler
 * generated from util-email.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef enum  {
	UTIL_DATE_CLOCK_FORMAT_TWELVE_HOURS,
	UTIL_DATE_CLOCK_FORMAT_TWENTY_FOUR_HOURS,
	UTIL_DATE_CLOCK_FORMAT_LOCALE_DEFAULT,
	UTIL_DATE_CLOCK_FORMAT_TOTAL
} UtilDateClockFormat;

#define UTIL_DATE_TYPE_CLOCK_FORMAT (util_date_clock_format_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

gint util_email_compare_conversation_ascending (GearyAppConversation* a,
                                                GearyAppConversation* b);
gint util_email_compare_conversation_descending (GearyAppConversation* a,
                                                 GearyAppConversation* b);
gchar* util_email_strip_subject_prefixes (GearyEmail* email);
GearyRFC822MailboxAddress* util_email_get_primary_originator (GearyEmailHeaderSet* email);
gchar* util_email_to_short_recipient_display (GearyRFC822MailboxAddresses* mailboxes);
GType util_date_clock_format_get_type (void) G_GNUC_CONST;
gchar* util_email_quote_email_for_reply (GearyEmail* email,
                                         const gchar* quote,
                                         UtilDateClockFormat clock_format,
                                         GearyRFC822TextFormat format);
gchar* util_date_get_full_date (UtilDateClockFormat clock_format);
gchar* util_email_quote_body (GearyEmail* email,
                              const gchar* html_quote,
                              gboolean use_quotes,
                              GearyRFC822TextFormat format,
                              GError** error);
gchar* util_email_quote_email_for_forward (GearyEmail* email,
                                           const gchar* quote,
                                           GearyRFC822TextFormat format);
gchar* util_email_shorten_url (const gchar* url);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

gint
util_email_compare_conversation_ascending (GearyAppConversation* a,
                                           GearyAppConversation* b)
{
	GearyEmail* a_latest = NULL;
	GearyEmail* _tmp0_;
	GearyEmail* b_latest = NULL;
	GearyEmail* _tmp1_;
	GearyEmail* _tmp2_;
	GearyEmail* _tmp6_;
	GearyEmail* _tmp7_;
	gint result = 0;
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (a, GEARY_APP_TYPE_CONVERSATION), 0);
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (b, GEARY_APP_TYPE_CONVERSATION), 0);
	_tmp0_ = geary_app_conversation_get_latest_recv_email (a, GEARY_APP_CONVERSATION_LOCATION_IN_FOLDER_OUT_OF_FOLDER, NULL);
	a_latest = _tmp0_;
	_tmp1_ = geary_app_conversation_get_latest_recv_email (b, GEARY_APP_CONVERSATION_LOCATION_IN_FOLDER_OUT_OF_FOLDER, NULL);
	b_latest = _tmp1_;
	_tmp2_ = a_latest;
	if (_tmp2_ == NULL) {
		gint _tmp3_ = 0;
		GearyEmail* _tmp4_;
		_tmp4_ = b_latest;
		if (_tmp4_ == NULL) {
			_tmp3_ = 0;
		} else {
			_tmp3_ = -1;
		}
		result = _tmp3_;
		_g_object_unref0 (b_latest);
		_g_object_unref0 (a_latest);
		return result;
	} else {
		GearyEmail* _tmp5_;
		_tmp5_ = b_latest;
		if (_tmp5_ == NULL) {
			result = 1;
			_g_object_unref0 (b_latest);
			_g_object_unref0 (a_latest);
			return result;
		}
	}
	_tmp6_ = a_latest;
	_tmp7_ = b_latest;
	result = geary_email_compare_recv_date_ascending (_tmp6_, _tmp7_);
	_g_object_unref0 (b_latest);
	_g_object_unref0 (a_latest);
	return result;
}

gint
util_email_compare_conversation_descending (GearyAppConversation* a,
                                            GearyAppConversation* b)
{
	gint result = 0;
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (a, GEARY_APP_TYPE_CONVERSATION), 0);
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (b, GEARY_APP_TYPE_CONVERSATION), 0);
	result = util_email_compare_conversation_ascending (b, a);
	return result;
}

/** Returns the stripped subject line, or a placeholder if none. */
gchar*
util_email_strip_subject_prefixes (GearyEmail* email)
{
	gchar* _tmp0_ = NULL;
	GearyRFC822Subject* _tmp1_;
	GearyRFC822Subject* _tmp2_;
	gchar* cleaned = NULL;
	gchar* _tmp6_;
	const gchar* _tmp7_ = NULL;
	const gchar* _tmp8_;
	gchar* _tmp10_;
	gchar* result = NULL;
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (email, GEARY_TYPE_EMAIL), NULL);
	_tmp1_ = geary_email_header_set_get_subject (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
	_tmp2_ = _tmp1_;
	if (_tmp2_ != NULL) {
		GearyRFC822Subject* _tmp3_;
		GearyRFC822Subject* _tmp4_;
		gchar* _tmp5_;
		_tmp3_ = geary_email_header_set_get_subject (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
		_tmp4_ = _tmp3_;
		_tmp5_ = geary_rf_c822_subject_strip_prefixes (_tmp4_);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp5_;
	} else {
		_g_free0 (_tmp0_);
		_tmp0_ = NULL;
	}
	_tmp6_ = g_strdup (_tmp0_);
	cleaned = _tmp6_;
	_tmp8_ = cleaned;
	if (!geary_string_is_empty (_tmp8_)) {
		const gchar* _tmp9_;
		_tmp9_ = cleaned;
		_tmp7_ = _tmp9_;
	} else {
		_tmp7_ = _ ("(no subject)");
	}
	_tmp10_ = g_strdup (_tmp7_);
	result = _tmp10_;
	_g_free0 (cleaned);
	_g_free0 (_tmp0_);
	return result;
}

/**
     * Returns a mailbox for the primary originator of an email.
     *
     * RFC 822 allows multiple and absent From header values, and
     * software such as Mailman and GitLab will mangle the names in
     * From mailboxes. This provides a canonical means to obtain a
     * mailbox (that is, name and email address) for the first
     * originator, and with the mailbox's name having been fixed up
     * where possible.
     *
     * The first From mailbox is used and de-mangled if found, if not
     * the Sender mailbox is used if present, else the first Reply-To
     * mailbox is used.
     */
static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

GearyRFC822MailboxAddress*
util_email_get_primary_originator (GearyEmailHeaderSet* email)
{
	GearyRFC822MailboxAddress* primary = NULL;
	gboolean _tmp0_ = FALSE;
	GearyRFC822MailboxAddresses* _tmp1_;
	GearyRFC822MailboxAddresses* _tmp2_;
	GearyRFC822MailboxAddress* result = NULL;
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (email, GEARY_TYPE_EMAIL_HEADER_SET), NULL);
	primary = NULL;
	_tmp1_ = geary_email_header_set_get_from (email);
	_tmp2_ = _tmp1_;
	if (_tmp2_ != NULL) {
		GearyRFC822MailboxAddresses* _tmp3_;
		GearyRFC822MailboxAddresses* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		_tmp3_ = geary_email_header_set_get_from (email);
		_tmp4_ = _tmp3_;
		_tmp5_ = geary_rf_c822_mailbox_addresses_get_size (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp0_ = _tmp6_ > 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GearyRFC822MailboxAddresses* from = NULL;
		GearyRFC822MailboxAddresses* _tmp7_;
		GearyRFC822MailboxAddresses* _tmp8_;
		GearyRFC822MailboxAddresses* _tmp9_;
		gchar* from_name = NULL;
		gchar* _tmp10_;
		gboolean _tmp11_ = FALSE;
		GearyRFC822MailboxAddresses* _tmp12_;
		GearyRFC822MailboxAddresses* reply_to = NULL;
		GearyRFC822MailboxAddresses* _tmp23_;
		GearyRFC822MailboxAddresses* _tmp24_;
		GearyRFC822MailboxAddresses* _tmp25_;
		GearyRFC822MailboxAddress* primary_reply_to = NULL;
		gchar* reply_to_name = NULL;
		gchar* _tmp26_;
		gboolean _tmp27_ = FALSE;
		GearyRFC822MailboxAddresses* _tmp28_;
		static const char VIA[] = " via ";
		gboolean _tmp39_ = FALSE;
		const gchar* _tmp40_;
		_tmp7_ = geary_email_header_set_get_from (email);
		_tmp8_ = _tmp7_;
		_tmp9_ = _g_object_ref0 (_tmp8_);
		from = _tmp9_;
		_tmp10_ = g_strdup ("");
		from_name = _tmp10_;
		_tmp12_ = from;
		if (_tmp12_ != NULL) {
			GearyRFC822MailboxAddresses* _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
			_tmp13_ = from;
			_tmp14_ = geary_rf_c822_mailbox_addresses_get_size (_tmp13_);
			_tmp15_ = _tmp14_;
			_tmp11_ = _tmp15_ > 0;
		} else {
			_tmp11_ = FALSE;
		}
		if (_tmp11_) {
			GearyRFC822MailboxAddresses* _tmp16_;
			GearyRFC822MailboxAddress* _tmp17_;
			const gchar* _tmp18_ = NULL;
			GearyRFC822MailboxAddress* _tmp19_;
			const gchar* _tmp20_;
			const gchar* _tmp21_;
			gchar* _tmp22_;
			_tmp16_ = from;
			_tmp17_ = geary_rf_c822_mailbox_addresses_get (_tmp16_, 0);
			_g_object_unref0 (primary);
			primary = _tmp17_;
			_tmp19_ = primary;
			_tmp20_ = geary_rf_c822_mailbox_address_get_name (_tmp19_);
			_tmp21_ = _tmp20_;
			_tmp18_ = _tmp21_;
			if (_tmp18_ == NULL) {
				_tmp18_ = "";
			}
			_tmp22_ = g_strdup (_tmp18_);
			_g_free0 (from_name);
			from_name = _tmp22_;
		}
		_tmp23_ = geary_email_header_set_get_reply_to (email);
		_tmp24_ = _tmp23_;
		_tmp25_ = _g_object_ref0 (_tmp24_);
		reply_to = _tmp25_;
		primary_reply_to = NULL;
		_tmp26_ = g_strdup ("");
		reply_to_name = _tmp26_;
		_tmp28_ = reply_to;
		if (_tmp28_ != NULL) {
			GearyRFC822MailboxAddresses* _tmp29_;
			gint _tmp30_;
			gint _tmp31_;
			_tmp29_ = reply_to;
			_tmp30_ = geary_rf_c822_mailbox_addresses_get_size (_tmp29_);
			_tmp31_ = _tmp30_;
			_tmp27_ = _tmp31_ > 0;
		} else {
			_tmp27_ = FALSE;
		}
		if (_tmp27_) {
			GearyRFC822MailboxAddresses* _tmp32_;
			GearyRFC822MailboxAddress* _tmp33_;
			const gchar* _tmp34_ = NULL;
			GearyRFC822MailboxAddress* _tmp35_;
			const gchar* _tmp36_;
			const gchar* _tmp37_;
			gchar* _tmp38_;
			_tmp32_ = reply_to;
			_tmp33_ = geary_rf_c822_mailbox_addresses_get (_tmp32_, 0);
			_g_object_unref0 (primary_reply_to);
			primary_reply_to = _tmp33_;
			_tmp35_ = primary_reply_to;
			_tmp36_ = geary_rf_c822_mailbox_address_get_name (_tmp35_);
			_tmp37_ = _tmp36_;
			_tmp34_ = _tmp37_;
			if (_tmp34_ == NULL) {
				_tmp34_ = "";
			}
			_tmp38_ = g_strdup (_tmp34_);
			_g_free0 (reply_to_name);
			reply_to_name = _tmp38_;
		}
		_tmp40_ = reply_to_name;
		if (g_strcmp0 (_tmp40_, "") != 0) {
			const gchar* _tmp41_;
			const gchar* _tmp42_;
			_tmp41_ = from_name;
			_tmp42_ = reply_to_name;
			_tmp39_ = g_str_has_prefix (_tmp41_, _tmp42_);
		} else {
			_tmp39_ = FALSE;
		}
		if (_tmp39_) {
			GearyRFC822MailboxAddress* _tmp43_;
			GearyRFC822MailboxAddress* _tmp44_;
			_tmp43_ = primary_reply_to;
			_tmp44_ = _g_object_ref0 (_tmp43_);
			_g_object_unref0 (primary);
			primary = _tmp44_;
		} else {
			const gchar* _tmp45_;
			_tmp45_ = from_name;
			if (string_contains (_tmp45_, VIA)) {
				const gchar* _tmp46_;
				gchar** _tmp47_;
				gchar** _tmp48_;
				gchar** _tmp49_;
				gint _tmp49__length1;
				const gchar* _tmp50_;
				GearyRFC822MailboxAddress* _tmp51_;
				const gchar* _tmp52_;
				const gchar* _tmp53_;
				GearyRFC822MailboxAddress* _tmp54_;
				_tmp46_ = from_name;
				_tmp48_ = _tmp47_ = g_strsplit (_tmp46_, VIA, 2);
				_tmp49_ = _tmp48_;
				_tmp49__length1 = _vala_array_length (_tmp47_);
				_tmp50_ = _tmp49_[0];
				_tmp51_ = primary;
				_tmp52_ = geary_rf_c822_mailbox_address_get_address (_tmp51_);
				_tmp53_ = _tmp52_;
				_tmp54_ = geary_rf_c822_mailbox_address_new (_tmp50_, _tmp53_);
				_g_object_unref0 (primary);
				primary = _tmp54_;
				_tmp49_ = (_vala_array_free (_tmp49_, _tmp49__length1, (GDestroyNotify) g_free), NULL);
			}
		}
		_g_free0 (reply_to_name);
		_g_object_unref0 (primary_reply_to);
		_g_object_unref0 (reply_to);
		_g_free0 (from_name);
		_g_object_unref0 (from);
	} else {
		GearyRFC822MailboxAddress* _tmp55_;
		GearyRFC822MailboxAddress* _tmp56_;
		_tmp55_ = geary_email_header_set_get_sender (email);
		_tmp56_ = _tmp55_;
		if (_tmp56_ != NULL) {
			GearyRFC822MailboxAddress* _tmp57_;
			GearyRFC822MailboxAddress* _tmp58_;
			GearyRFC822MailboxAddress* _tmp59_;
			_tmp57_ = geary_email_header_set_get_sender (email);
			_tmp58_ = _tmp57_;
			_tmp59_ = _g_object_ref0 (_tmp58_);
			_g_object_unref0 (primary);
			primary = _tmp59_;
		} else {
			gboolean _tmp60_ = FALSE;
			GearyRFC822MailboxAddresses* _tmp61_;
			GearyRFC822MailboxAddresses* _tmp62_;
			_tmp61_ = geary_email_header_set_get_reply_to (email);
			_tmp62_ = _tmp61_;
			if (_tmp62_ != NULL) {
				GearyRFC822MailboxAddresses* _tmp63_;
				GearyRFC822MailboxAddresses* _tmp64_;
				gint _tmp65_;
				gint _tmp66_;
				_tmp63_ = geary_email_header_set_get_reply_to (email);
				_tmp64_ = _tmp63_;
				_tmp65_ = geary_rf_c822_mailbox_addresses_get_size (_tmp64_);
				_tmp66_ = _tmp65_;
				_tmp60_ = _tmp66_ > 0;
			} else {
				_tmp60_ = FALSE;
			}
			if (_tmp60_) {
				GearyRFC822MailboxAddresses* _tmp67_;
				GearyRFC822MailboxAddresses* _tmp68_;
				GearyRFC822MailboxAddress* _tmp69_;
				_tmp67_ = geary_email_header_set_get_reply_to (email);
				_tmp68_ = _tmp67_;
				_tmp69_ = geary_rf_c822_mailbox_addresses_get (_tmp68_, 0);
				_g_object_unref0 (primary);
				primary = _tmp69_;
			}
		}
	}
	result = primary;
	return result;
}

/**
     * Returns a shortened recipient list suitable for display.
     *
     * This is useful in case there are a lot of recipients, or there
     * is little room for the display.
     *
     * @return a string containing at least the first mailbox
     * serialised by {@link MailboxAddress.to_short_display}, if the
     * list contains more mailboxes then an indication of how many
     * additional are present.
     */
gchar*
util_email_to_short_recipient_display (GearyRFC822MailboxAddresses* mailboxes)
{
	gint _tmp0_;
	gint _tmp1_;
	gchar* first_recipient = NULL;
	GearyRFC822MailboxAddress* _tmp3_;
	GearyRFC822MailboxAddress* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	const gchar* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gchar* _tmp14_;
	gchar* result = NULL;
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (mailboxes, GEARY_RF_C822_TYPE_MAILBOX_ADDRESSES), NULL);
	_tmp0_ = geary_rf_c822_mailbox_addresses_get_size (mailboxes);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == 0) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (_ ("(No recipients)"));
		result = _tmp2_;
		return result;
	}
	_tmp3_ = geary_rf_c822_mailbox_addresses_get (mailboxes, 0);
	_tmp4_ = _tmp3_;
	_tmp5_ = geary_rf_c822_mailbox_address_to_short_display (_tmp4_);
	_tmp6_ = _tmp5_;
	_g_object_unref0 (_tmp4_);
	first_recipient = _tmp6_;
	_tmp7_ = geary_rf_c822_mailbox_addresses_get_size (mailboxes);
	_tmp8_ = _tmp7_;
	if (_tmp8_ == 1) {
		result = first_recipient;
		return result;
	}
	_tmp9_ = geary_rf_c822_mailbox_addresses_get_size (mailboxes);
	_tmp10_ = _tmp9_;
	_tmp11_ = first_recipient;
	_tmp12_ = geary_rf_c822_mailbox_addresses_get_size (mailboxes);
	_tmp13_ = _tmp12_;
	_tmp14_ = g_strdup_printf (ngettext ("%s and %d other", "%s and %d others", (gulong) (_tmp10_ - 1)), _tmp11_, _tmp13_ - 1);
	result = _tmp14_;
	_g_free0 (first_recipient);
	return result;
}

/**
     * Returns a quoted text string needed for a reply.
     *
     * If there's no message body in the supplied email or quote text, this
     * function will return the empty string.
     *
     * If html_format is true, the message will be quoted in HTML format.
     * Otherwise it will be in plain text.
     */
gchar*
util_email_quote_email_for_reply (GearyEmail* email,
                                  const gchar* quote,
                                  UtilDateClockFormat clock_format,
                                  GearyRFC822TextFormat format)
{
	gboolean _tmp0_ = FALSE;
	GearyRFC822Text* _tmp1_;
	GearyRFC822Text* _tmp2_;
	gchar* quoted = NULL;
	gchar* _tmp4_;
	gchar* DATE_FORMAT = NULL;
	gchar* _tmp5_;
	gboolean _tmp6_ = FALSE;
	GearyRFC822Date* _tmp7_;
	GearyRFC822Date* _tmp8_;
	const gchar* _tmp55_;
	gchar* _tmp56_;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (email, GEARY_TYPE_EMAIL), NULL);
	_tmp1_ = geary_email_get_body (email);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == NULL) {
		_tmp0_ = quote == NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gchar* _tmp3_;
		_tmp3_ = g_strdup ("");
		result = _tmp3_;
		return result;
	}
	_tmp4_ = g_strdup ("");
	quoted = _tmp4_;
	_tmp5_ = util_date_get_full_date (clock_format);
	DATE_FORMAT = _tmp5_;
	_tmp7_ = geary_email_header_set_get_date (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
	_tmp8_ = _tmp7_;
	if (_tmp8_ != NULL) {
		GearyRFC822MailboxAddresses* _tmp9_;
		GearyRFC822MailboxAddresses* _tmp10_;
		_tmp9_ = geary_email_header_set_get_from (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
		_tmp10_ = _tmp9_;
		_tmp6_ = _tmp10_ != NULL;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		gchar* QUOTED_LABEL = NULL;
		gchar* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		GearyRFC822Date* _tmp14_;
		GearyRFC822Date* _tmp15_;
		GDateTime* _tmp16_;
		GDateTime* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		GearyRFC822MailboxAddresses* _tmp21_;
		GearyRFC822MailboxAddresses* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		_tmp11_ = g_strdup (_ ("On %1$s, %2$s wrote:"));
		QUOTED_LABEL = _tmp11_;
		_tmp12_ = quoted;
		_tmp13_ = QUOTED_LABEL;
		_tmp14_ = geary_email_header_set_get_date (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
		_tmp15_ = _tmp14_;
		_tmp16_ = geary_rf_c822_date_get_value (_tmp15_);
		_tmp17_ = _tmp16_;
		_tmp18_ = DATE_FORMAT;
		_tmp19_ = g_date_time_format (_tmp17_, _tmp18_);
		_tmp20_ = _tmp19_;
		_tmp21_ = geary_email_header_set_get_from (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
		_tmp22_ = _tmp21_;
		_tmp23_ = geary_rf_c822_utils_email_addresses_for_reply (_tmp22_, format);
		_tmp24_ = _tmp23_;
		_tmp25_ = g_strdup_printf (_tmp13_, _tmp20_, _tmp24_);
		_tmp26_ = _tmp25_;
		_tmp27_ = g_strconcat (_tmp12_, _tmp26_, NULL);
		_g_free0 (quoted);
		quoted = _tmp27_;
		_g_free0 (_tmp26_);
		_g_free0 (_tmp24_);
		_g_free0 (_tmp20_);
		_g_free0 (QUOTED_LABEL);
	} else {
		GearyRFC822MailboxAddresses* _tmp28_;
		GearyRFC822MailboxAddresses* _tmp29_;
		_tmp28_ = geary_email_header_set_get_from (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
		_tmp29_ = _tmp28_;
		if (_tmp29_ != NULL) {
			gchar* QUOTED_LABEL = NULL;
			gchar* _tmp30_;
			const gchar* _tmp31_;
			const gchar* _tmp32_;
			GearyRFC822MailboxAddresses* _tmp33_;
			GearyRFC822MailboxAddresses* _tmp34_;
			gchar* _tmp35_;
			gchar* _tmp36_;
			gchar* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
			_tmp30_ = g_strdup (_ ("%s wrote:"));
			QUOTED_LABEL = _tmp30_;
			_tmp31_ = quoted;
			_tmp32_ = QUOTED_LABEL;
			_tmp33_ = geary_email_header_set_get_from (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
			_tmp34_ = _tmp33_;
			_tmp35_ = geary_rf_c822_utils_email_addresses_for_reply (_tmp34_, format);
			_tmp36_ = _tmp35_;
			_tmp37_ = g_strdup_printf (_tmp32_, _tmp36_);
			_tmp38_ = _tmp37_;
			_tmp39_ = g_strconcat (_tmp31_, _tmp38_, NULL);
			_g_free0 (quoted);
			quoted = _tmp39_;
			_g_free0 (_tmp38_);
			_g_free0 (_tmp36_);
			_g_free0 (QUOTED_LABEL);
		} else {
			GearyRFC822Date* _tmp40_;
			GearyRFC822Date* _tmp41_;
			_tmp40_ = geary_email_header_set_get_date (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
			_tmp41_ = _tmp40_;
			if (_tmp41_ != NULL) {
				gchar* QUOTED_LABEL = NULL;
				gchar* _tmp42_;
				const gchar* _tmp43_;
				const gchar* _tmp44_;
				GearyRFC822Date* _tmp45_;
				GearyRFC822Date* _tmp46_;
				GDateTime* _tmp47_;
				GDateTime* _tmp48_;
				const gchar* _tmp49_;
				gchar* _tmp50_;
				gchar* _tmp51_;
				gchar* _tmp52_;
				gchar* _tmp53_;
				gchar* _tmp54_;
				_tmp42_ = g_strdup (_ ("On %s:"));
				QUOTED_LABEL = _tmp42_;
				_tmp43_ = quoted;
				_tmp44_ = QUOTED_LABEL;
				_tmp45_ = geary_email_header_set_get_date (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
				_tmp46_ = _tmp45_;
				_tmp47_ = geary_rf_c822_date_get_value (_tmp46_);
				_tmp48_ = _tmp47_;
				_tmp49_ = DATE_FORMAT;
				_tmp50_ = g_date_time_format (_tmp48_, _tmp49_);
				_tmp51_ = _tmp50_;
				_tmp52_ = g_strdup_printf (_tmp44_, _tmp51_);
				_tmp53_ = _tmp52_;
				_tmp54_ = g_strconcat (_tmp43_, _tmp53_, NULL);
				_g_free0 (quoted);
				quoted = _tmp54_;
				_g_free0 (_tmp53_);
				_g_free0 (_tmp51_);
				_g_free0 (QUOTED_LABEL);
			}
		}
	}
	_tmp55_ = quoted;
	_tmp56_ = g_strconcat (_tmp55_, "<br />", NULL);
	_g_free0 (quoted);
	quoted = _tmp56_;
	{
		gchar* _tmp57_ = NULL;
		gchar* _tmp58_;
		const gchar* _tmp59_;
		gchar* _tmp60_;
		gchar* _tmp61_;
		gchar* _tmp62_;
		_tmp58_ = util_email_quote_body (email, quote, TRUE, format, &_inner_error0_);
		_tmp57_ = _tmp58_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch187_g_error;
		}
		_tmp59_ = quoted;
		_tmp60_ = _tmp57_;
		_tmp57_ = NULL;
		_tmp61_ = _tmp60_;
		_tmp62_ = g_strconcat (_tmp59_, _tmp61_, NULL);
		_g_free0 (quoted);
		quoted = _tmp62_;
		_g_free0 (_tmp61_);
		_g_free0 (_tmp57_);
	}
	goto __finally187;
	__catch187_g_error:
	{
		GError* err = NULL;
		GError* _tmp63_;
		const gchar* _tmp64_;
		gchar* _tmp65_;
		gchar* _tmp66_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp63_ = err;
		_tmp64_ = _tmp63_->message;
		_tmp65_ = g_strdup_printf ("Failed to quote body for replying: %s", _tmp64_);
		_tmp66_ = _tmp65_;
		g_debug ("util-email.vala:181: %s", _tmp66_);
		_g_free0 (_tmp66_);
		_g_error_free0 (err);
	}
	__finally187:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (DATE_FORMAT);
		_g_free0 (quoted);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	result = quoted;
	_g_free0 (DATE_FORMAT);
	return result;
}

/**
     * Returns a quoted text string needed for a forward.
     *
     * If there's no message body in the supplied email or quote text, this
     * function will return the empty string.
     *
     * If html_format is true, the message will be quoted in HTML format.
     * Otherwise it will be in plain text.
     */
static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch188_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch188_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally188;
	__catch188_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally188:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

gchar*
util_email_quote_email_for_forward (GearyEmail* email,
                                    const gchar* quote,
                                    GearyRFC822TextFormat format)
{
	gboolean _tmp0_ = FALSE;
	GearyRFC822Text* _tmp1_;
	GearyRFC822Text* _tmp2_;
	static const char HEADER_FORMAT[] = "%s %s\n";
	gchar* quoted = NULL;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* from_line = NULL;
	GearyRFC822MailboxAddresses* _tmp7_;
	GearyRFC822MailboxAddresses* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp16_ = NULL;
	GearyRFC822Subject* _tmp17_;
	GearyRFC822Subject* _tmp18_;
	const gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_ = NULL;
	GearyRFC822Date* _tmp28_;
	GearyRFC822Date* _tmp29_;
	const gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* to_line = NULL;
	GearyRFC822MailboxAddresses* _tmp38_;
	GearyRFC822MailboxAddresses* _tmp39_;
	gchar* _tmp40_;
	const gchar* _tmp41_;
	gchar* cc_line = NULL;
	GearyRFC822MailboxAddresses* _tmp47_;
	GearyRFC822MailboxAddresses* _tmp48_;
	gchar* _tmp49_;
	const gchar* _tmp50_;
	const gchar* _tmp56_;
	gchar* _tmp57_;
	const gchar* _tmp58_;
	gchar* _tmp59_;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (email, GEARY_TYPE_EMAIL), NULL);
	_tmp1_ = geary_email_get_body (email);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == NULL) {
		_tmp0_ = quote == NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gchar* _tmp3_;
		_tmp3_ = g_strdup ("");
		result = _tmp3_;
		return result;
	}
	_tmp4_ = g_strdup (_ ("---------- Forwarded message ----------"));
	quoted = _tmp4_;
	_tmp5_ = quoted;
	_tmp6_ = g_strconcat (_tmp5_, "\n", NULL);
	_g_free0 (quoted);
	quoted = _tmp6_;
	_tmp7_ = geary_email_header_set_get_from (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
	_tmp8_ = _tmp7_;
	_tmp9_ = geary_rf_c822_utils_email_addresses_for_reply (_tmp8_, format);
	from_line = _tmp9_;
	_tmp10_ = from_line;
	if (!geary_string_is_empty_or_whitespace (_tmp10_)) {
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		_tmp11_ = quoted;
		_tmp12_ = from_line;
		_tmp13_ = g_strdup_printf (HEADER_FORMAT, _ ("From:"), _tmp12_);
		_tmp14_ = _tmp13_;
		_tmp15_ = g_strconcat (_tmp11_, _tmp14_, NULL);
		_g_free0 (quoted);
		quoted = _tmp15_;
		_g_free0 (_tmp14_);
	}
	_tmp17_ = geary_email_header_set_get_subject (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
	_tmp18_ = _tmp17_;
	if (_tmp18_ != NULL) {
		GearyRFC822Subject* _tmp19_;
		GearyRFC822Subject* _tmp20_;
		gchar* _tmp21_;
		_tmp19_ = geary_email_header_set_get_subject (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
		_tmp20_ = _tmp19_;
		_tmp21_ = geary_message_data_abstract_message_data_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEARY_MESSAGE_DATA_TYPE_ABSTRACT_MESSAGE_DATA, GearyMessageDataAbstractMessageData));
		_g_free0 (_tmp16_);
		_tmp16_ = _tmp21_;
	} else {
		gchar* _tmp22_;
		_tmp22_ = g_strdup ("");
		_g_free0 (_tmp16_);
		_tmp16_ = _tmp22_;
	}
	_tmp23_ = quoted;
	_tmp24_ = g_strdup_printf (HEADER_FORMAT, _ ("Subject:"), _tmp16_);
	_tmp25_ = _tmp24_;
	_tmp26_ = g_strconcat (_tmp23_, _tmp25_, NULL);
	_g_free0 (quoted);
	quoted = _tmp26_;
	_g_free0 (_tmp25_);
	_tmp28_ = geary_email_header_set_get_date (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
	_tmp29_ = _tmp28_;
	if (_tmp29_ != NULL) {
		GearyRFC822Date* _tmp30_;
		GearyRFC822Date* _tmp31_;
		gchar* _tmp32_;
		_tmp30_ = geary_email_header_set_get_date (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
		_tmp31_ = _tmp30_;
		_tmp32_ = geary_message_data_abstract_message_data_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, GEARY_MESSAGE_DATA_TYPE_ABSTRACT_MESSAGE_DATA, GearyMessageDataAbstractMessageData));
		_g_free0 (_tmp27_);
		_tmp27_ = _tmp32_;
	} else {
		gchar* _tmp33_;
		_tmp33_ = g_strdup ("");
		_g_free0 (_tmp27_);
		_tmp27_ = _tmp33_;
	}
	_tmp34_ = quoted;
	_tmp35_ = g_strdup_printf (HEADER_FORMAT, _ ("Date:"), _tmp27_);
	_tmp36_ = _tmp35_;
	_tmp37_ = g_strconcat (_tmp34_, _tmp36_, NULL);
	_g_free0 (quoted);
	quoted = _tmp37_;
	_g_free0 (_tmp36_);
	_tmp38_ = geary_email_header_set_get_to (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
	_tmp39_ = _tmp38_;
	_tmp40_ = geary_rf_c822_utils_email_addresses_for_reply (_tmp39_, format);
	to_line = _tmp40_;
	_tmp41_ = to_line;
	if (!geary_string_is_empty_or_whitespace (_tmp41_)) {
		const gchar* _tmp42_;
		const gchar* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_;
		gchar* _tmp46_;
		_tmp42_ = quoted;
		_tmp43_ = to_line;
		_tmp44_ = g_strdup_printf (HEADER_FORMAT, _ ("To:"), _tmp43_);
		_tmp45_ = _tmp44_;
		_tmp46_ = g_strconcat (_tmp42_, _tmp45_, NULL);
		_g_free0 (quoted);
		quoted = _tmp46_;
		_g_free0 (_tmp45_);
	}
	_tmp47_ = geary_email_header_set_get_cc (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
	_tmp48_ = _tmp47_;
	_tmp49_ = geary_rf_c822_utils_email_addresses_for_reply (_tmp48_, format);
	cc_line = _tmp49_;
	_tmp50_ = cc_line;
	if (!geary_string_is_empty_or_whitespace (_tmp50_)) {
		const gchar* _tmp51_;
		const gchar* _tmp52_;
		gchar* _tmp53_;
		gchar* _tmp54_;
		gchar* _tmp55_;
		_tmp51_ = quoted;
		_tmp52_ = cc_line;
		_tmp53_ = g_strdup_printf (HEADER_FORMAT, _ ("Cc:"), _tmp52_);
		_tmp54_ = _tmp53_;
		_tmp55_ = g_strconcat (_tmp51_, _tmp54_, NULL);
		_g_free0 (quoted);
		quoted = _tmp55_;
		_g_free0 (_tmp54_);
	}
	_tmp56_ = quoted;
	_tmp57_ = g_strconcat (_tmp56_, "\n", NULL);
	_g_free0 (quoted);
	quoted = _tmp57_;
	_tmp58_ = quoted;
	_tmp59_ = string_replace (_tmp58_, "\n", "<br />");
	_g_free0 (quoted);
	quoted = _tmp59_;
	{
		gchar* _tmp60_ = NULL;
		gchar* _tmp61_;
		const gchar* _tmp62_;
		gchar* _tmp63_;
		gchar* _tmp64_;
		gchar* _tmp65_;
		_tmp61_ = util_email_quote_body (email, quote, FALSE, format, &_inner_error0_);
		_tmp60_ = _tmp61_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch189_g_error;
		}
		_tmp62_ = quoted;
		_tmp63_ = _tmp60_;
		_tmp60_ = NULL;
		_tmp64_ = _tmp63_;
		_tmp65_ = g_strconcat (_tmp62_, _tmp64_, NULL);
		_g_free0 (quoted);
		quoted = _tmp65_;
		_g_free0 (_tmp64_);
		_g_free0 (_tmp60_);
	}
	goto __finally189;
	__catch189_g_error:
	{
		GError* err = NULL;
		GError* _tmp66_;
		const gchar* _tmp67_;
		gchar* _tmp68_;
		gchar* _tmp69_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp66_ = err;
		_tmp67_ = _tmp66_->message;
		_tmp68_ = g_strdup_printf ("Failed to quote body for forwarding: %s", _tmp67_);
		_tmp69_ = _tmp68_;
		g_debug ("util-email.vala:228: %s", _tmp69_);
		_g_free0 (_tmp69_);
		_g_error_free0 (err);
	}
	__finally189:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (cc_line);
		_g_free0 (to_line);
		_g_free0 (_tmp27_);
		_g_free0 (_tmp16_);
		_g_free0 (from_line);
		_g_free0 (quoted);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	result = quoted;
	_g_free0 (cc_line);
	_g_free0 (to_line);
	_g_free0 (_tmp27_);
	_g_free0 (_tmp16_);
	_g_free0 (from_line);
	return result;
}

gchar*
util_email_quote_body (GearyEmail* email,
                       const gchar* html_quote,
                       gboolean use_quotes,
                       GearyRFC822TextFormat format,
                       GError** error)
{
	GearyRFC822Message* message = NULL;
	GearyRFC822Message* _tmp0_;
	gchar* body_text = NULL;
	gboolean _tmp16_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (email, GEARY_TYPE_EMAIL), NULL);
	_tmp0_ = geary_email_get_message (email, &_inner_error0_);
	message = _tmp0_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return NULL;
	}
	body_text = NULL;
	if (geary_string_is_empty (html_quote)) {
		switch (format) {
			case GEARY_RF_C822_TEXT_FORMAT_HTML:
			{
				gchar* _tmp1_ = NULL;
				GearyRFC822Message* _tmp2_;
				gchar* _tmp7_;
				_tmp2_ = message;
				if (geary_rf_c822_message_has_html_body (_tmp2_)) {
					GearyRFC822Message* _tmp3_;
					gchar* _tmp4_;
					_tmp3_ = message;
					_tmp4_ = geary_rf_c822_message_get_html_body (_tmp3_, NULL, NULL, &_inner_error0_);
					_g_free0 (_tmp1_);
					_tmp1_ = _tmp4_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						g_propagate_error (error, _inner_error0_);
						_g_free0 (_tmp1_);
						_g_free0 (body_text);
						_g_object_unref0 (message);
						return NULL;
					}
				} else {
					GearyRFC822Message* _tmp5_;
					gchar* _tmp6_;
					_tmp5_ = message;
					_tmp6_ = geary_rf_c822_message_get_plain_body (_tmp5_, TRUE, NULL, NULL, &_inner_error0_);
					_g_free0 (_tmp1_);
					_tmp1_ = _tmp6_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						g_propagate_error (error, _inner_error0_);
						_g_free0 (_tmp1_);
						_g_free0 (body_text);
						_g_object_unref0 (message);
						return NULL;
					}
				}
				_tmp7_ = g_strdup (_tmp1_);
				_g_free0 (body_text);
				body_text = _tmp7_;
				_g_free0 (_tmp1_);
				break;
			}
			case GEARY_RF_C822_TEXT_FORMAT_PLAIN:
			{
				gchar* _tmp8_ = NULL;
				GearyRFC822Message* _tmp9_;
				gchar* _tmp14_;
				_tmp9_ = message;
				if (geary_rf_c822_message_has_plain_body (_tmp9_)) {
					GearyRFC822Message* _tmp10_;
					gchar* _tmp11_;
					_tmp10_ = message;
					_tmp11_ = geary_rf_c822_message_get_plain_body (_tmp10_, TRUE, NULL, NULL, &_inner_error0_);
					_g_free0 (_tmp8_);
					_tmp8_ = _tmp11_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						g_propagate_error (error, _inner_error0_);
						_g_free0 (_tmp8_);
						_g_free0 (body_text);
						_g_object_unref0 (message);
						return NULL;
					}
				} else {
					GearyRFC822Message* _tmp12_;
					gchar* _tmp13_;
					_tmp12_ = message;
					_tmp13_ = geary_rf_c822_message_get_html_body (_tmp12_, NULL, NULL, &_inner_error0_);
					_g_free0 (_tmp8_);
					_tmp8_ = _tmp13_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						g_propagate_error (error, _inner_error0_);
						_g_free0 (_tmp8_);
						_g_free0 (body_text);
						_g_object_unref0 (message);
						return NULL;
					}
				}
				_tmp14_ = g_strdup (_tmp8_);
				_g_free0 (body_text);
				body_text = _tmp14_;
				_g_free0 (_tmp8_);
				break;
			}
			default:
			break;
		}
	} else {
		gchar* _tmp15_;
		_tmp15_ = g_strdup (html_quote);
		_g_free0 (body_text);
		body_text = _tmp15_;
	}
	if (use_quotes) {
		const gchar* _tmp17_;
		_tmp17_ = body_text;
		_tmp16_ = !geary_string_is_empty (_tmp17_);
	} else {
		_tmp16_ = FALSE;
	}
	if (_tmp16_) {
		const gchar* _tmp18_;
		gchar* _tmp19_;
		_tmp18_ = body_text;
		_tmp19_ = g_strdup_printf ("<blockquote type=\"cite\">%s</blockquote>", _tmp18_);
		_g_free0 (body_text);
		body_text = _tmp19_;
	}
	result = body_text;
	_g_object_unref0 (message);
	return result;
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result = 0L;
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
	end = _tmp0_;
	_tmp1_ = end;
	if (_tmp1_ == NULL) {
		result = maxlen;
		return result;
	} else {
		gchar* _tmp2_;
		_tmp2_ = end;
		result = (glong) (_tmp2_ - str);
		return result;
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	if (offset >= ((glong) 0)) {
		_tmp0_ = len >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		string_length = string_strnlen ((gchar*) self, offset + len);
	} else {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = strlen (self);
		_tmp2_ = _tmp1_;
		string_length = (glong) _tmp2_;
	}
	if (offset < ((glong) 0)) {
		offset = string_length + offset;
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
	} else {
		g_return_val_if_fail (offset <= string_length, NULL);
	}
	if (len < ((glong) 0)) {
		len = string_length - offset;
	}
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
	result = _tmp3_;
	return result;
}

gchar*
util_email_shorten_url (const gchar* url)
{
	gchar* new_url = NULL;
	gchar* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gchar* result = NULL;
	g_return_val_if_fail (url != NULL, NULL);
	_tmp0_ = g_strdup ("");
	new_url = _tmp0_;
	_tmp1_ = strlen (url);
	_tmp2_ = _tmp1_;
	if (_tmp2_ < 90) {
		gchar* _tmp3_;
		_tmp3_ = g_strdup (url);
		_g_free0 (new_url);
		new_url = _tmp3_;
	} else {
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp4_ = string_substring (url, (glong) 0, (glong) 40);
		_tmp5_ = _tmp4_;
		_tmp6_ = g_strconcat (_tmp5_, "...", NULL);
		_tmp7_ = _tmp6_;
		_tmp8_ = string_substring (url, (glong) -40, (glong) -1);
		_tmp9_ = _tmp8_;
		_tmp10_ = g_strconcat (_tmp7_, _tmp9_, NULL);
		_g_free0 (new_url);
		new_url = _tmp10_;
		_g_free0 (_tmp9_);
		_g_free0 (_tmp7_);
		_g_free0 (_tmp5_);
	}
	result = new_url;
	return result;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

