/* memory-unowned-string-buffer.c generated by valac 0.46.13, the Vala compiler
 * generated from memory-unowned-string-buffer.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#define GEARY_MEMORY_TYPE_UNOWNED_STRING_BUFFER (geary_memory_unowned_string_buffer_get_type ())
#define GEARY_MEMORY_UNOWNED_STRING_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_MEMORY_TYPE_UNOWNED_STRING_BUFFER, GearyMemoryUnownedStringBuffer))
#define GEARY_MEMORY_IS_UNOWNED_STRING_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_MEMORY_TYPE_UNOWNED_STRING_BUFFER))
#define GEARY_MEMORY_UNOWNED_STRING_BUFFER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEARY_MEMORY_TYPE_UNOWNED_STRING_BUFFER, GearyMemoryUnownedStringBufferIface))

typedef struct _GearyMemoryUnownedStringBuffer GearyMemoryUnownedStringBuffer;
typedef struct _GearyMemoryUnownedStringBufferIface GearyMemoryUnownedStringBufferIface;

#define GEARY_TYPE_BASE_OBJECT (geary_base_object_get_type ())
#define GEARY_BASE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_BASE_OBJECT, GearyBaseObject))
#define GEARY_BASE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_BASE_OBJECT, GearyBaseObjectClass))
#define GEARY_IS_BASE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_BASE_OBJECT))
#define GEARY_IS_BASE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_BASE_OBJECT))
#define GEARY_BASE_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_BASE_OBJECT, GearyBaseObjectClass))

typedef struct _GearyBaseObject GearyBaseObject;
typedef struct _GearyBaseObjectClass GearyBaseObjectClass;

#define GEARY_MEMORY_TYPE_BUFFER (geary_memory_buffer_get_type ())
#define GEARY_MEMORY_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_MEMORY_TYPE_BUFFER, GearyMemoryBuffer))
#define GEARY_MEMORY_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_MEMORY_TYPE_BUFFER, GearyMemoryBufferClass))
#define GEARY_MEMORY_IS_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_MEMORY_TYPE_BUFFER))
#define GEARY_MEMORY_IS_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_MEMORY_TYPE_BUFFER))
#define GEARY_MEMORY_BUFFER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_MEMORY_TYPE_BUFFER, GearyMemoryBufferClass))

typedef struct _GearyMemoryBuffer GearyMemoryBuffer;
typedef struct _GearyMemoryBufferClass GearyMemoryBufferClass;

struct _GearyMemoryUnownedStringBufferIface {
	GTypeInterface parent_iface;
	const gchar* (*to_unowned_string) (GearyMemoryUnownedStringBuffer* self);
};

GType geary_base_object_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GearyBaseObject, g_object_unref)
GType geary_memory_buffer_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GearyMemoryBuffer, g_object_unref)
GType geary_memory_unowned_string_buffer_get_type (void) G_GNUC_CONST;
const gchar* geary_memory_unowned_string_buffer_to_unowned_string (GearyMemoryUnownedStringBuffer* self);

/**
     * Returns an unowned string version of the backing buffer.
     *
     * The returned string should not be modified or freed.
     */
const gchar*
geary_memory_unowned_string_buffer_to_unowned_string (GearyMemoryUnownedStringBuffer* self)
{
	g_return_val_if_fail (GEARY_MEMORY_IS_UNOWNED_STRING_BUFFER (self), NULL);
	return GEARY_MEMORY_UNOWNED_STRING_BUFFER_GET_INTERFACE (self)->to_unowned_string (self);
}

static void
geary_memory_unowned_string_buffer_default_init (GearyMemoryUnownedStringBufferIface * iface,
                                                 gpointer iface_data)
{
}

/**
 * Interface which allows access to backing string of {@link Memory.Buffer} without transferring
 * ownership, i.e. copying the string.
 *
 * The presence of this interface indicates that obtaining access to the backing string is cheap.
 *
 * Not all AbstractBuffers can support this call, but if they can, this interface allows for it.
 * The buffers that are returned should ''not'' be modified or freed by the caller.
 */
GType
geary_memory_unowned_string_buffer_get_type (void)
{
	static volatile gsize geary_memory_unowned_string_buffer_type_id__volatile = 0;
	if (g_once_init_enter (&geary_memory_unowned_string_buffer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GearyMemoryUnownedStringBufferIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_memory_unowned_string_buffer_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType geary_memory_unowned_string_buffer_type_id;
		geary_memory_unowned_string_buffer_type_id = g_type_register_static (G_TYPE_INTERFACE, "GearyMemoryUnownedStringBuffer", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (geary_memory_unowned_string_buffer_type_id, GEARY_MEMORY_TYPE_BUFFER);
		g_once_init_leave (&geary_memory_unowned_string_buffer_type_id__volatile, geary_memory_unowned_string_buffer_type_id);
	}
	return geary_memory_unowned_string_buffer_type_id__volatile;
}

