/* util-loggable.c generated by valac 0.46.13, the Vala compiler
 * generated from util-loggable.vala, do not modify */

/*
 * Copyright 2018-2019 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <stdarg.h>

#define GEARY_TYPE_LOGGABLE (geary_loggable_get_type ())
#define GEARY_LOGGABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_LOGGABLE, GearyLoggable))
#define GEARY_IS_LOGGABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_LOGGABLE))
#define GEARY_LOGGABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEARY_TYPE_LOGGABLE, GearyLoggableIface))

typedef struct _GearyLoggable GearyLoggable;
typedef struct _GearyLoggableIface GearyLoggableIface;
typedef enum  {
	GEARY_LOGGING_FLAG_NONE = 0,
	GEARY_LOGGING_FLAG_NETWORK = 1 << 0,
	GEARY_LOGGING_FLAG_SERIALIZER = 1 << 1,
	GEARY_LOGGING_FLAG_REPLAY = 1 << 2,
	GEARY_LOGGING_FLAG_CONVERSATIONS = 1 << 3,
	GEARY_LOGGING_FLAG_PERIODIC = 1 << 4,
	GEARY_LOGGING_FLAG_SQL = 1 << 5,
	GEARY_LOGGING_FLAG_FOLDER_NORMALIZATION = 1 << 6,
	GEARY_LOGGING_FLAG_DESERIALIZER = 1 << 7,
	GEARY_LOGGING_FLAG_ALL = G_MAXINT
} GearyLoggingFlag;

#define GEARY_LOGGING_TYPE_FLAG (geary_logging_flag_get_type ())

#define GEARY_LOGGABLE_TYPE_CONTEXT (geary_loggable_context_get_type ())
typedef struct _GearyLoggableContext GearyLoggableContext;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _GearyLoggableIface {
	GTypeInterface parent_iface;
	gchar* (*to_string) (GearyLoggable* self);
	GearyLoggingFlag (*get_loggable_flags) (GearyLoggable* self);
	void (*set_loggable_flags) (GearyLoggable* self, GearyLoggingFlag value);
	GearyLoggable* (*get_loggable_parent) (GearyLoggable* self);
};

struct _GearyLoggableContext {
	GLogField* fields;
	gint fields_length1;
	guint8 len;
	guint8 count;
	gchar* message;
};

GType geary_logging_flag_get_type (void) G_GNUC_CONST;
GType geary_loggable_get_type (void) G_GNUC_CONST;
static gchar* geary_loggable_log_level_to_priority (GLogLevelFlags level);
gchar* geary_loggable_to_string (GearyLoggable* self);
void geary_loggable_debug (GearyLoggable* self,
                           const gchar* fmt,
                           ...) G_GNUC_PRINTF(2,3);
static inline void geary_loggable_log_structured (GearyLoggable* self,
                                    GearyLoggingFlag flags,
                                    GLogLevelFlags levels,
                                    const gchar* fmt,
                                    va_list args);
GearyLoggingFlag geary_loggable_get_loggable_flags (GearyLoggable* self);
void geary_loggable_message (GearyLoggable* self,
                             const gchar* fmt,
                             ...) G_GNUC_PRINTF(2,3);
void geary_loggable_warning (GearyLoggable* self,
                             const gchar* fmt,
                             ...) G_GNUC_PRINTF(2,3);
void geary_loggable_error (GearyLoggable* self,
                           const gchar* fmt,
                           ...) G_GNUC_PRINTF(2,3);
void geary_loggable_critical (GearyLoggable* self,
                              const gchar* fmt,
                              ...) G_GNUC_PRINTF(2,3);
GType geary_loggable_context_get_type (void) G_GNUC_CONST;
GearyLoggableContext* geary_loggable_context_dup (const GearyLoggableContext* self);
void geary_loggable_context_free (GearyLoggableContext* self);
void geary_loggable_context_copy (const GearyLoggableContext* self,
                                  GearyLoggableContext* dest);
void geary_loggable_context_destroy (GearyLoggableContext* self);
#define GEARY_LOGGING_DOMAIN "Geary"
static void geary_loggable_context_init (GearyLoggableContext *self,
                                  const gchar* domain,
                                  GearyLoggingFlag flags,
                                  GLogLevelFlags level,
                                  const gchar* message,
                                  va_list args);
void geary_loggable_context_append_loggable (GearyLoggableContext *self,
                                             GearyLoggable* value);
GearyLoggable* geary_loggable_get_loggable_parent (GearyLoggable* self);
GLogField* geary_loggable_context_to_array (GearyLoggableContext *self,
                                            gint* result_length1);
void geary_loggable_set_loggable_flags (GearyLoggable* self,
                                        GearyLoggingFlag value);
#define GEARY_LOGGABLE_CONTEXT_FIELD_COUNT ((guint8) 8)
void geary_loggable_context_append (GearyLoggableContext *self,
                                    GType t_type,
                                    GBoxedCopyFunc t_dup_func,
                                    GDestroyNotify t_destroy_func,
                                    const gchar* key,
                                    gconstpointer value);
static GLogField* _vala_array_dup16 (GLogField* self,
                              int length);
static GLogField* _vala_array_dup17 (GLogField* self,
                              int length);

static gchar*
geary_loggable_log_level_to_priority (GLogLevelFlags level)
{
	gchar* _tmp6_;
	gchar* result = NULL;
	if ((level & G_LOG_LEVEL_ERROR) == G_LOG_LEVEL_ERROR) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup ("3");
		result = _tmp0_;
		return result;
	}
	if ((level & G_LOG_LEVEL_CRITICAL) == G_LOG_LEVEL_CRITICAL) {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("4");
		result = _tmp1_;
		return result;
	}
	if ((level & G_LOG_LEVEL_WARNING) == G_LOG_LEVEL_WARNING) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup ("4");
		result = _tmp2_;
		return result;
	}
	if ((level & G_LOG_LEVEL_MESSAGE) == G_LOG_LEVEL_MESSAGE) {
		gchar* _tmp3_;
		_tmp3_ = g_strdup ("5");
		result = _tmp3_;
		return result;
	}
	if ((level & G_LOG_LEVEL_INFO) == G_LOG_LEVEL_INFO) {
		gchar* _tmp4_;
		_tmp4_ = g_strdup ("6");
		result = _tmp4_;
		return result;
	}
	if ((level & G_LOG_LEVEL_DEBUG) == G_LOG_LEVEL_DEBUG) {
		gchar* _tmp5_;
		_tmp5_ = g_strdup ("7");
		result = _tmp5_;
		return result;
	}
	_tmp6_ = g_strdup ("5");
	result = _tmp6_;
	return result;
}

/**
     * Returns a string representation of the service, for debugging.
     */
gchar*
geary_loggable_to_string (GearyLoggable* self)
{
	g_return_val_if_fail (GEARY_IS_LOGGABLE (self), NULL);
	return GEARY_LOGGABLE_GET_INTERFACE (self)->to_string (self);
}

/**
     * Logs a debug-level log message with this object as context.
     */
inline void
geary_loggable_debug (GearyLoggable* self,
                      const gchar* fmt,
                      ...)
{
	GearyLoggingFlag _tmp0_;
	GearyLoggingFlag _tmp1_;
	va_list _tmp2_ = {0};
	g_return_if_fail (fmt != NULL);
	_tmp0_ = geary_loggable_get_loggable_flags (self);
	_tmp1_ = _tmp0_;
	va_start (_tmp2_, fmt);
	geary_loggable_log_structured (self, _tmp1_, G_LOG_LEVEL_DEBUG, fmt, _tmp2_);
	va_end (_tmp2_);
}

/**
     * Logs a message-level log message with this object as context.
     */
inline void
geary_loggable_message (GearyLoggable* self,
                        const gchar* fmt,
                        ...)
{
	GearyLoggingFlag _tmp0_;
	GearyLoggingFlag _tmp1_;
	va_list _tmp2_ = {0};
	g_return_if_fail (fmt != NULL);
	_tmp0_ = geary_loggable_get_loggable_flags (self);
	_tmp1_ = _tmp0_;
	va_start (_tmp2_, fmt);
	geary_loggable_log_structured (self, _tmp1_, G_LOG_LEVEL_MESSAGE, fmt, _tmp2_);
	va_end (_tmp2_);
}

/**
     * Logs a warning-level log message with this object as context.
     */
inline void
geary_loggable_warning (GearyLoggable* self,
                        const gchar* fmt,
                        ...)
{
	GearyLoggingFlag _tmp0_;
	GearyLoggingFlag _tmp1_;
	va_list _tmp2_ = {0};
	g_return_if_fail (fmt != NULL);
	_tmp0_ = geary_loggable_get_loggable_flags (self);
	_tmp1_ = _tmp0_;
	va_start (_tmp2_, fmt);
	geary_loggable_log_structured (self, _tmp1_, G_LOG_LEVEL_WARNING, fmt, _tmp2_);
	va_end (_tmp2_);
}

/**
     * Logs a error-level log message with this object as context.
     */
inline void
geary_loggable_error (GearyLoggable* self,
                      const gchar* fmt,
                      ...)
{
	GearyLoggingFlag _tmp0_;
	GearyLoggingFlag _tmp1_;
	va_list _tmp2_ = {0};
	g_return_if_fail (fmt != NULL);
	_tmp0_ = geary_loggable_get_loggable_flags (self);
	_tmp1_ = _tmp0_;
	va_start (_tmp2_, fmt);
	geary_loggable_log_structured (self, _tmp1_, G_LOG_LEVEL_ERROR, fmt, _tmp2_);
	va_end (_tmp2_);
}

/**
     * Logs a critical-level log message with this object as context.
     */
inline void
geary_loggable_critical (GearyLoggable* self,
                         const gchar* fmt,
                         ...)
{
	GearyLoggingFlag _tmp0_;
	GearyLoggingFlag _tmp1_;
	va_list _tmp2_ = {0};
	g_return_if_fail (fmt != NULL);
	_tmp0_ = geary_loggable_get_loggable_flags (self);
	_tmp1_ = _tmp0_;
	va_start (_tmp2_, fmt);
	geary_loggable_log_structured (self, _tmp1_, G_LOG_LEVEL_CRITICAL, fmt, _tmp2_);
	va_end (_tmp2_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static inline void
geary_loggable_log_structured (GearyLoggable* self,
                               GearyLoggingFlag flags,
                               GLogLevelFlags levels,
                               const gchar* fmt,
                               va_list args)
{
	GearyLoggableContext context = {0};
	GearyLoggable* decorated = NULL;
	GearyLoggable* _tmp0_;
	gint _tmp7_ = 0;
	GLogField* _tmp8_;
	GLogField* _tmp9_;
	gint _tmp9__length1;
	g_return_if_fail (fmt != NULL);
	geary_loggable_context_init (&context, GEARY_LOGGING_DOMAIN, flags, levels, fmt, args);
	_tmp0_ = _g_object_ref0 (self);
	decorated = _tmp0_;
	while (TRUE) {
		GearyLoggable* _tmp1_;
		GearyLoggable* _tmp2_;
		GearyLoggable* _tmp3_;
		GearyLoggable* _tmp4_;
		GearyLoggable* _tmp5_;
		GearyLoggable* _tmp6_;
		_tmp1_ = decorated;
		if (!(_tmp1_ != NULL)) {
			break;
		}
		_tmp2_ = decorated;
		geary_loggable_context_append_loggable (&context, _tmp2_);
		_tmp3_ = decorated;
		_tmp4_ = geary_loggable_get_loggable_parent (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = _g_object_ref0 (_tmp5_);
		_g_object_unref0 (decorated);
		decorated = _tmp6_;
	}
	_tmp8_ = geary_loggable_context_to_array (&context, &_tmp7_);
	_tmp9_ = _tmp8_;
	_tmp9__length1 = _tmp7_;
	g_log_structured_array (levels, _tmp9_, (gint) _tmp7_);
	_tmp9_ = (g_free (_tmp9_), NULL);
	_g_object_unref0 (decorated);
	geary_loggable_context_destroy (&context);
}

GearyLoggingFlag
geary_loggable_get_loggable_flags (GearyLoggable* self)
{
	g_return_val_if_fail (GEARY_IS_LOGGABLE (self), 0U);
	return GEARY_LOGGABLE_GET_INTERFACE (self)->get_loggable_flags (self);
}

void
geary_loggable_set_loggable_flags (GearyLoggable* self,
                                   GearyLoggingFlag value)
{
	g_return_if_fail (GEARY_IS_LOGGABLE (self));
	GEARY_LOGGABLE_GET_INTERFACE (self)->set_loggable_flags (self, value);
}

GearyLoggable*
geary_loggable_get_loggable_parent (GearyLoggable* self)
{
	g_return_val_if_fail (GEARY_IS_LOGGABLE (self), NULL);
	return GEARY_LOGGABLE_GET_INTERFACE (self)->get_loggable_parent (self);
}

static void
geary_loggable_context_init (GearyLoggableContext *self,
                             const gchar* domain,
                             GearyLoggingFlag flags,
                             GLogLevelFlags level,
                             const gchar* message,
                             va_list args)
{
	GLogField* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	va_list _tmp3_ = {0};
	gchar* _tmp4_;
	g_return_if_fail (domain != NULL);
	g_return_if_fail (message != NULL);
	memset (self, 0, sizeof (GearyLoggableContext));
	_tmp0_ = g_new0 (GLogField, GEARY_LOGGABLE_CONTEXT_FIELD_COUNT);
	(*self).fields = (g_free ((*self).fields), NULL);
	(*self).fields = _tmp0_;
	(*self).fields_length1 = GEARY_LOGGABLE_CONTEXT_FIELD_COUNT;
	(*self).len = GEARY_LOGGABLE_CONTEXT_FIELD_COUNT;
	(*self).count = (guint8) 0;
	_tmp1_ = geary_loggable_log_level_to_priority (level);
	_tmp2_ = _tmp1_;
	geary_loggable_context_append (&(*self), G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, "PRIORITY", _tmp2_);
	_g_free0 (_tmp2_);
	geary_loggable_context_append (&(*self), G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, "GLIB_DOMAIN", domain);
	geary_loggable_context_append (&(*self), GEARY_LOGGING_TYPE_FLAG, NULL, NULL, "GEARY_FLAGS", (gpointer) ((gintptr) flags));
	va_copy (_tmp3_, args);
	_tmp4_ = g_strdup_vprintf (message, _tmp3_);
	_g_free0 ((*self).message);
	(*self).message = _tmp4_;
	va_end (_tmp3_);
}

void
geary_loggable_context_append (GearyLoggableContext *self,
                               GType t_type,
                               GBoxedCopyFunc t_dup_func,
                               GDestroyNotify t_destroy_func,
                               const gchar* key,
                               gconstpointer value)
{
	guint8 count = 0U;
	GLogField* _tmp1_;
	gint _tmp1__length1;
	GLogField* _tmp2_;
	gint _tmp2__length1;
	gint _tmp3_ = 0;
	GLogField* _tmp4_;
	gint _tmp4__length1;
	guint8 _tmp5_;
	g_return_if_fail (key != NULL);
	count = (*self).count;
	if ((count + 1) >= ((gint) (*self).len)) {
		gint _tmp0_;
		_tmp0_ = (gint) ((*self).len + GEARY_LOGGABLE_CONTEXT_FIELD_COUNT);
		(*self).fields = g_renew (GLogField, (*self).fields, (gint) ((*self).len + GEARY_LOGGABLE_CONTEXT_FIELD_COUNT));
		(_tmp0_ > (*self).fields_length1) ? memset ((*self).fields + (*self).fields_length1, 0, sizeof (GLogField) * (_tmp0_ - (*self).fields_length1)) : NULL;
		(*self).fields_length1 = _tmp0_;
	}
	_tmp1_ = (*self).fields;
	_tmp1__length1 = (*self).fields_length1;
	_tmp1_[count].key = key;
	_tmp2_ = (*self).fields;
	_tmp2__length1 = (*self).fields_length1;
	_tmp2_[count].value = value;
	if (t_type == G_TYPE_STRING) {
		_tmp3_ = -1;
	} else {
		_tmp3_ = 0;
	}
	_tmp4_ = (*self).fields;
	_tmp4__length1 = (*self).fields_length1;
	_tmp4_[count].length = (gssize) _tmp3_;
	_tmp5_ = (*self).count;
	(*self).count = _tmp5_ + 1;
}

inline void
geary_loggable_context_append_loggable (GearyLoggableContext *self,
                                        GearyLoggable* value)
{
	g_return_if_fail (GEARY_IS_LOGGABLE (value));
	geary_loggable_context_append (&(*self), GEARY_TYPE_LOGGABLE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, "GEARY_LOGGABLE", value);
}

static GLogField*
_vala_array_dup16 (GLogField* self,
                   int length)
{
	if (length > 0) {
		return g_memdup (self, length * sizeof (GLogField));
	}
	return NULL;
}

GLogField*
geary_loggable_context_to_array (GearyLoggableContext *self,
                                 gint* result_length1)
{
	const gchar* _tmp0_;
	GLogField* _tmp1_;
	gint _tmp1__length1;
	GLogField* _tmp2_;
	gint _tmp2__length1;
	GLogField* _tmp3_;
	gint _tmp3__length1;
	GLogField* result = NULL;
	_tmp0_ = (*self).message;
	geary_loggable_context_append (&(*self), G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, "MESSAGE", _tmp0_);
	_tmp1_ = (*self).fields;
	_tmp1__length1 = (*self).fields_length1;
	_tmp2_ = ((_tmp1_ + 0) != NULL) ? _vala_array_dup16 (_tmp1_ + 0, ((gint) (*self).count) - 0) : ((gpointer) (_tmp1_ + 0));
	_tmp2__length1 = ((gint) (*self).count) - 0;
	_tmp3_ = _tmp2_;
	_tmp3__length1 = _tmp2__length1;
	if (result_length1) {
		*result_length1 = _tmp3__length1;
	}
	result = _tmp3_;
	return result;
}

static GLogField*
_vala_array_dup17 (GLogField* self,
                   int length)
{
	if (length > 0) {
		return g_memdup (self, length * sizeof (GLogField));
	}
	return NULL;
}

void
geary_loggable_context_copy (const GearyLoggableContext* self,
                             GearyLoggableContext* dest)
{
	GLogField* _tmp0_;
	gint _tmp0__length1;
	GLogField* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	_tmp0_ = (*self).fields;
	_tmp0__length1 = (*self).fields_length1;
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup17 (_tmp0_, _tmp0__length1) : ((gpointer) _tmp0_);
	_tmp1__length1 = _tmp0__length1;
	(*dest).fields = (g_free ((*dest).fields), NULL);
	(*dest).fields = _tmp1_;
	(*dest).fields_length1 = _tmp1__length1;
	(*dest).len = (*self).len;
	(*dest).count = (*self).count;
	_tmp2_ = (*self).message;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 ((*dest).message);
	(*dest).message = _tmp3_;
}

void
geary_loggable_context_destroy (GearyLoggableContext* self)
{
	(*self).fields = (g_free ((*self).fields), NULL);
	_g_free0 ((*self).message);
}

GearyLoggableContext*
geary_loggable_context_dup (const GearyLoggableContext* self)
{
	GearyLoggableContext* dup;
	dup = g_new0 (GearyLoggableContext, 1);
	geary_loggable_context_copy (self, dup);
	return dup;
}

void
geary_loggable_context_free (GearyLoggableContext* self)
{
	geary_loggable_context_destroy (self);
	g_free (self);
}

GType
geary_loggable_context_get_type (void)
{
	static volatile gsize geary_loggable_context_type_id__volatile = 0;
	if (g_once_init_enter (&geary_loggable_context_type_id__volatile)) {
		GType geary_loggable_context_type_id;
		geary_loggable_context_type_id = g_boxed_type_register_static ("GearyLoggableContext", (GBoxedCopyFunc) geary_loggable_context_dup, (GBoxedFreeFunc) geary_loggable_context_free);
		g_once_init_leave (&geary_loggable_context_type_id__volatile, geary_loggable_context_type_id);
	}
	return geary_loggable_context_type_id__volatile;
}

static void
geary_loggable_default_init (GearyLoggableIface * iface,
                             gpointer iface_data)
{
	/**
	     * Default flags to use for this loggable when logging messages.
	     */
	g_object_interface_install_property (iface, g_param_spec_flags ("loggable-flags", "loggable-flags", "loggable-flags", GEARY_LOGGING_TYPE_FLAG, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * The parent of this loggable.
	     *
	     * If not null, the parent and its ancestors recursively will be
	     * added to to log message context.
	     */
	g_object_interface_install_property (iface, g_param_spec_object ("loggable-parent", "loggable-parent", "loggable-parent", GEARY_TYPE_LOGGABLE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

/**
 * Mixin interface for objects that support structured logging.
 *
 * Loggable objects provide both a standard means to obtain a string
 * representation of the object for display to humans, and keep a weak
 * reference to some parent loggable, enabling this context to be
 * automatically added to logging calls. For example, if a Foo object
 * is the loggable parent of a Bar object, log calls made by Bar will
 * automatically be decorated with Foo.
 */
GType
geary_loggable_get_type (void)
{
	static volatile gsize geary_loggable_type_id__volatile = 0;
	if (g_once_init_enter (&geary_loggable_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GearyLoggableIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_loggable_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType geary_loggable_type_id;
		geary_loggable_type_id = g_type_register_static (G_TYPE_INTERFACE, "GearyLoggable", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (geary_loggable_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&geary_loggable_type_id__volatile, geary_loggable_type_id);
	}
	return geary_loggable_type_id__volatile;
}

